Editor Window Customization in Vue Scheduler
The Schedule component uses popups and dialog windows to display notifications and includes an editor window containing event fields that simplify appointment creation and modification. The editor window and its fields can be customized, and validation rules can be applied where necessary.
Event Editor
The editor window usually opens on the Scheduler when a cell or event is double-clicked. When a cell is double-clicked, the detailed editor window opens in Add New mode, whereas when an event is double-clicked, it opens in Edit mode.
On mobile devices, the detailed editor window can be opened in edit mode by tapping the edit icon in the popup displayed after tapping an event. Tapping a cell displays a + indicator, which opens the editor in add mode when tapped again.
The editor window can be prevented from opening by enabling the
readonlymode or by customizing behavior within thepopupOpenevent.
How to change the editor window header title and text of footer buttons
The header title and footer button text of the editor window can be modified by customizing the localized word collection used in the Schedule component.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate' :views='views'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { L10n } from '@syncfusion/ej2-base';
import { ScheduleComponent as EjsSchedule, Day, Week, TimelineViews, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
L10n.load({
'en-US': {
'schedule': {
'saveButton': 'Add',
'cancelButton': 'Close',
'deleteButton': 'Remove',
'newEvent': 'Add Event',
},
}
});
const height = '550px';
const width = '100%';
const views = ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'];
const eventSettings = { dataSource: scheduleData };
const selectedDate = new Date(2018, 1, 15);
provide('schedule', [Day, Week, TimelineViews, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate' :views='views'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script>
import { L10n } from '@syncfusion/ej2-base';
import { ScheduleComponent, Day, Week, TimelineViews, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
L10n.load({
'en-US': {
'schedule': {
'saveButton': 'Add',
'cancelButton': 'Close',
'deleteButton': 'Remove',
'newEvent': 'Add Event',
},
}
});
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'],
eventSettings: { dataSource: scheduleData },
selectedDate: new Date(2018, 1, 15),
}
},
provide: {
schedule: [Day, Week, TimelineViews, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to change the label text of default editor fields
Default field labels such as Subject, Location, and others can be customized using the title property of the eventSettings field options.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate' :views='views'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, TimelineViews, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'];
const eventSettings = {
dataSource: scheduleData,
fields: {
id: 'Id',
subject: { name: 'Subject', title: 'Event Name' },
location: { name: 'Location', title: 'Event Location' },
description: { name: 'Description', title: 'Event Description' },
startTime: { name: 'StartTime', title: 'Start Duration' },
endTime: { name: 'EndTime', title: 'End Duration' }
}
};
const selectedDate = new Date(2018, 1, 15);
provide('schedule', [Day, Week, TimelineViews, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate' :views='views'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, TimelineViews, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'],
eventSettings: {
dataSource: scheduleData,
fields: {
id: 'Id',
subject: { name: 'Subject', title: 'Event Name' },
location: { name: 'Location', title: 'Event Location' },
description: { name: 'Description', title: 'Event Description' },
startTime: { name: 'StartTime', title: 'Start Duration' },
endTime: { name: 'EndTime', title: 'End Duration' }
}
},
selectedDate: new Date(2018, 1, 15),
}
},
provide: {
schedule: [Day, Week, TimelineViews, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>Field Validation
It is possible to validate the required fields of the editor window on the client side before submitting it by adding appropriate validation rules to each field. The appointment fields have been extended to accept both string and object type values. To perform validations, it is necessary to specify object values for the event fields.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const minValidation = (args) => {
return args['value'].length >= 5;
};
const height = '550px';
const width = '100%';
const eventSettings = {
dataSource: scheduleData,
fields: {
id: 'Id',
subject: { name: 'Subject', validation: { required: true } },
location: { name: 'Location', validation: { required: true } },
description: {
name: 'Description', validation: {
required: true, minLength: [minValidation, 'Need atleast 5 letters to be entered']
}
},
startTime: { name: 'StartTime', validation: { required: true } },
endTime: { name: 'EndTime', validation: { required: true } }
}
};
const selectedDate = new Date(2018, 1, 15);
provide('schedule', [Day, Week, WorkWeek, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :selectedDate='selectedDate'
:eventSettings='eventSettings'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
let minValidation = (args) => {
return args['value'].length >= 5;
};
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
eventSettings: {
dataSource: scheduleData,
fields: {
id: 'Id',
subject: { name: 'Subject', validation: { required: true } },
location: { name: 'Location', validation: { required: true } },
description: {
name: 'Description', validation: {
required: true, minLength: [minValidation, 'Need atleast 5 letters to be entered']
}
},
startTime: { name: 'StartTime', validation: { required: true } },
endTime: { name: 'EndTime', validation: { required: true } }
}
},
selectedDate: new Date(2018, 1, 15),
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>Validation rules are detailed in the form validation documentation.
Add additional fields to the default editor
Additional fields can be added to the default event editor by using the popupOpen event, which is triggered before the event editor opens on the Scheduler. The popupOpen event is a client-side event that triggers before any of the generic popups open on the Scheduler. The additional field, or any other form element, should be added with a common class name e-field so that the additional data can be handled and processed along with the default event object. In the following example, an additional field Event Type has been added to the default event editor and its value is processed accordingly.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { createElement } from '@syncfusion/ej2-base';
import { eventData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
if (args.type === 'Editor') {
// Create required custom elements in initial time
if (!args.element.querySelector('.custom-field-row')) {
let row = createElement('div', { className: 'custom-field-row' });
let formElement = args.element.querySelector('.e-schedule-form');
formElement.firstChild.insertBefore(row, args.element.querySelector('.e-title-location-row'));
let container = createElement('div', { className: 'custom-field-container' });
let inputEle = createElement('input', {
className: 'e-field', attrs: { name: 'EventType' }
});
container.appendChild(inputEle);
row.appendChild(container);
let dropDownList = new DropDownList({
dataSource: [
{ text: 'Public Event', value: 'public-event' },
{ text: 'Maintenance', value: 'maintenance' },
{ text: 'Commercial Event', value: 'commercial-event' },
{ text: 'Family Event', value: 'family-event' }
],
fields: { text: 'text', value: 'value' },
value: args.data.EventType,
floatLabelType: 'Always', placeholder: 'Event Type'
});
dropDownList.appendTo(inputEle);
inputEle.setAttribute('name', 'EventType');
}
}
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-field-row {
padding-bottom: 14px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { createElement } from '@syncfusion/ej2-base';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'Editor') {
// Create required custom elements in initial time
if (!args.element.querySelector('.custom-field-row')) {
let row = createElement('div', { className: 'custom-field-row' });
let formElement = args.element.querySelector('.e-schedule-form');
formElement.firstChild.insertBefore(row, args.element.querySelector('.e-title-location-row'));
let container = createElement('div', { className: 'custom-field-container' });
let inputEle = createElement('input', {
className: 'e-field', attrs: { name: 'EventType' }
});
container.appendChild(inputEle);
row.appendChild(container);
let dropDownList = new DropDownList({
dataSource: [
{ text: 'Public Event', value: 'public-event' },
{ text: 'Maintenance', value: 'maintenance' },
{ text: 'Commercial Event', value: 'commercial-event' },
{ text: 'Family Event', value: 'family-event' }
],
fields: { text: 'text', value: 'value' },
value: args.data.EventType,
floatLabelType: 'Always', placeholder: 'Event Type'
});
dropDownList.appendTo(inputEle);
inputEle.setAttribute('name', 'EventType');
}
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-field-row {
padding-bottom: 14px;
}
</style>Customizing the default time duration in editor window
The default time interval for start and end times in the editor is determined by the interval value within the timeScale property. By default, the interval value is set to 30, and therefore the start and end time duration within the event editor is 30 minutes. You can change this duration by changing the duration option within the popupOpen event, as shown in the following code example.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
if (args.type === 'Editor') {
args.duration = 60;
}
};
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'Editor') {
args.duration = 60;
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Prevent the Display of Editor and Quick Popups
To prevent the editor or quick popups from opening, assign true to the cancel option in the popupOpen event.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
args.cancel = true;
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onPopupOpen: function (args) {
args.cancel = true;
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>When preventing only specific popups, conditional checks can be performed based on popup type. Supported popup types within the popupOpen event include.
| Type | Description |
|---|---|
| Editor | For the detailed editor window. |
| QuickInfo | For the quick popup that opens on cell click. |
| EditEventInfo | For the quick popup that opens on event click. |
| ViewEventInfo | For the quick popup that opens in responsive mode. |
| EventContainer | For the more event indicator popup. |
| RecurrenceAlert | For the recurrence edit alert popup. |
| DeleteAlert | For the delete confirmation popup. |
| ValidationAlert | For the validation alert popup. |
| RecurrenceValidationAlert | For the recurrence validation alert popup. |
Customizing Timezone Collection in the Editor Window
By default, the timezone collections in the editor window are loaded with built-in timezone values. You can customize the timezone collections using the timezoneDataSource property with the collection of TimezoneFields data.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :selectedDate='selectedDate' :views='views' :eventSettings='eventSettings'
:timezoneDataSource='timezoneDataSource'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
let data = [{
Id: 1,
Subject: 'Explosion of Betelgeuse Star',
StartTime: new Date(2020, 1, 15, 10, 0),
EndTime: new Date(2018, 1, 15, 12, 30),
IsAllDay: false
}, {
Id: 2,
Subject: 'Blue Moon Eclipse',
StartTime: new Date(2020, 1, 16, 12, 0),
EndTime: new Date(2018, 1, 16, 13, 0),
IsAllDay: false
}];
const height = '550px';
const views = ['Day', 'Week', 'Month', 'Agenda'];
const eventSettings = { dataSource: data };
const timezoneDataSource = [
{ Value: 'Pacific/Niue', Text: 'Niue' },
{ Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
{ Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
{ Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
{ Value: 'Pacific/Tahiti', Text: 'Tahiti' },
];
const selectedDate = new Date(2020, 1, 15);
provide('schedule', [Day, Week, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :selectedDate='selectedDate' :views='views' :eventSettings='eventSettings'
:timezoneDataSource='timezoneDataSource'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
let data = [{
Id: 1,
Subject: 'Explosion of Betelgeuse Star',
StartTime: new Date(2020, 1, 15, 10, 0),
EndTime: new Date(2018, 1, 15, 12, 30),
IsAllDay: false
}, {
Id: 2,
Subject: 'Blue Moon Eclipse',
StartTime: new Date(2020, 1, 16, 12, 0),
EndTime: new Date(2018, 1, 16, 13, 0),
IsAllDay: false
}];
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
views: ['Day', 'Week', 'Month', 'Agenda'],
eventSettings: { dataSource: data },
timezoneDataSource: [
{ Value: 'Pacific/Niue', Text: 'Niue' },
{ Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
{ Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
{ Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
{ Value: 'Pacific/Tahiti', Text: 'Tahiti' },
],
selectedDate: new Date(2020, 1, 15),
}
},
provide: {
schedule: [Day, Week, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>Customizing Event Editor using Template
The event editor window can be customized using the editorTemplate option. Here, the custom window design is built with the required fields using a script template, and its type should be text/x-template.
Each field defined within the template should contain the e-field class so that those field values can be processed internally. The ID of this customized script template section is assigned to the editorTemplate option, so that these customized fields replace the default editor window.
Note: The e-field class is only applicable to DropDownList, DateTimePicker, MultiSelect, DatePicker, CheckBox, and TextBox components, because their field values are processed internally.
Because the following example uses Syncfusion® subcomponents within the editor template, the custom form elements must be configured as the required Syncfusion® components such as DropDownList and DateTimePicker within the popupOpen event. This step can be skipped if you want to use standard form elements.
Watch this video for more information on how to customize an editor window using a template in the Vue Scheduler:
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'">
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><ejs-dropdownlist id='EventType' name="EventType" class="e-field" placeholder= 'Choose status' :dataSource='statusData' >
</ejs-dropdownlist>
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownListComponent as EjsDropdownlist } from '@syncfusion/ej2-vue-dropdowns';
import { DateTimePickerComponent as EjsDatetimepicker } from '@syncfusion/ej2-vue-calendars';
import { eventData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const showQuickInfo = false;
const statusData = ['New', 'Requested', 'Confirmed'];
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'">
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><ejs-dropdownlist id='EventType' name="EventType" class="e-field" placeholder= 'Choose status' :dataSource='statusData' >
</ejs-dropdownlist>
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';
import { DropDownListComponent } from '@syncfusion/ej2-vue-dropdowns';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent,
"ejs-datetimepicker": DateTimePickerComponent,
"ejs-dropdownlist": DropDownListComponent,
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15),
showQuickInfo: false,
statusData: ['New', 'Requested', 'Confirmed']
};
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style>How to Customize Header and Footer using Template
The editor window’s header and footer can be enhanced with custom designs using the editorHeaderTemplate and editorFooterTemplate options. To achieve this, create a script template that includes the necessary fields. Ensure that the template type is set to text/x-template.
In this demo, we tailor the editor’s header according to the appointment’s subject field using the editorHeaderTemplate. Furthermore, we make use of the editorFooterTemplate to handle the functionality of validating specific fields before proceeding with the save action or canceling it if validation requirements are not met.
<template>
<div id="app">
<div id="container">
<ejs-schedule :height="height" :width="width" ref='schedule_instance' :eventSettings="eventSettings"
:editorHeaderTemplate="'editorHeaderTemplate'" :editorFooterTemplate="'editorFooterTemplate'"
:popupOpen="onPopupOpen">
<template v-slot:editorHeaderTemplate="{ data }">
<div class="event-header"></div>
</template>
<template v-slot:editorFooterTemplate="{ data }">
<div id="event-footer">
<div id="verify">
<input type="checkbox" id="check-box" value="unchecked" />
<label htmlFor="check-box" id="text">Verified</label>
</div>
<div id="right-button">
<button id="Save" className="e-control e-btn e-primary" disabled data-ripple="true"> Save</button>
<button id="Cancel" className="e-control e-btn e-primary" data-ripple="true"> Cancel </button>
</div>
</div>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from "@syncfusion/ej2-vue-schedule";
const schedule_instance = ref(null);
const today = new Date();
var data = [
{
Id: 1,
Subject: "Surgery - Andrew",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 9, 0),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 10, 0),
IsAllDay: false
},
{
Id: 2,
Subject: "Consulting - John",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 10, 0),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 11, 30),
IsAllDay: false
},
{
Id: 3,
Subject: "Therapy - Robert",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 11, 30),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 12, 30),
IsAllDay: false
},
{
Id: 4,
Subject: "Observation - Steven",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 12, 30),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 13, 30),
IsAllDay: false
},
];
const height = "550px";
const width = "100%";
const eventSettings = { dataSource: data };
const onPopupOpen = function (args) {
if (args.type === "Editor") {
let scheduleObj = schedule_instance.value.ej2Instances
const saveButton = args.element.querySelector("#Save");
const cancelButton = args.element.querySelector("#Cancel");
const checkBox = args.element.querySelector("#check-box");
checkBox.onchange = () => {
if (!checkBox.checked) {
saveButton.setAttribute("disabled", "");
} else {
saveButton.removeAttribute("disabled");
}
};
saveButton.onclick = () => {
const data = {
Id: args.data.Id,
Subject: args.element.querySelector("#Subject").value,
StartTime: args.element.querySelector("#StartTime").ej2_instances[0].value,
EndTime: args.element.querySelector("#EndTime").ej2_instances[0].value,
IsAllDay: args.element.querySelector("#IsAllDay").checked,
};
if (args.target?.classList.contains("e-appointment")) {
scheduleObj.saveEvent(data, "Save");
} else {
data.Id = scheduleObj.getEventMaxID();
scheduleObj.addEvent(data);
}
scheduleObj.closeEditor();
};
cancelButton.onclick = () => {
scheduleObj.closeEditor();
};
}
};
const getName = function (value) {
return value.Subject ? value.Subject : 'Create New Event';
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
#verify {
position: fixed;
padding: 0 20px;
}
#text {
cursor: pointer;
display: inline-block;
font-family: "Roboto", -apple-system, BlinkMacSystemFont, "Segoe UI", "Helvetica Neue", sans-serif;
font-size: 14px;
font-weight: normal;
line-height: 14px;
user-select: none;
margin-left: 8px;
vertical-align: middle;
white-space: normal;
}
#right-button {
padding: 0 10px;
}
</style><template>
<div id="app">
<div id="container">
<ejs-schedule :height="height" :width="width" ref='schedule_instance' :eventSettings="eventSettings"
:editorHeaderTemplate="'editorHeaderTemplate'" :editorFooterTemplate="'editorFooterTemplate'"
:popupOpen="onPopupOpen">
<template v-slot:editorHeaderTemplate="{ data }">
<div class="event-header"></div>
</template>
<template v-slot:editorFooterTemplate="{ data }">
<div id="event-footer">
<div id="verify">
<input type="checkbox" id="check-box" value="unchecked" />
<label htmlFor="check-box" id="text">Verified</label>
</div>
<div id="right-button">
<button id="Save" className="e-control e-btn e-primary" disabled data-ripple="true"> Save</button>
<button id="Cancel" className="e-control e-btn e-primary" data-ripple="true"> Cancel </button>
</div>
</div>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from "@syncfusion/ej2-vue-schedule";
const today = new Date();
var data = [
{
Id: 1,
Subject: "Surgery - Andrew",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 9, 0),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 10, 0),
IsAllDay: false
},
{
Id: 2,
Subject: "Consulting - John",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 10, 0),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 11, 30),
IsAllDay: false
},
{
Id: 3,
Subject: "Therapy - Robert",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 11, 30),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 12, 30),
IsAllDay: false
},
{
Id: 4,
Subject: "Observation - Steven",
StartTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 12, 30),
EndTime: new Date(today.getFullYear(), today.getMonth(), today.getDate(), 13, 30),
IsAllDay: false
},
];
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: "550px",
width: "100%",
eventSettings: { dataSource: data }
};
},
methods: {
onPopupOpen: function (args) {
if (args.type === "Editor") {
let scheduleObj = this.$refs.schedule_instance.ej2Instances
const saveButton = args.element.querySelector("#Save");
const cancelButton = args.element.querySelector("#Cancel");
const checkBox = args.element.querySelector("#check-box");
checkBox.onchange = () => {
if (!checkBox.checked) {
saveButton.setAttribute("disabled", "");
} else {
saveButton.removeAttribute("disabled");
}
};
saveButton.onclick = () => {
const data = {
Id: args.data.Id,
Subject: args.element.querySelector("#Subject").value,
StartTime: args.element.querySelector("#StartTime").ej2_instances[0].value,
EndTime: args.element.querySelector("#EndTime").ej2_instances[0].value,
IsAllDay: args.element.querySelector("#IsAllDay").checked,
};
if (args.target?.classList.contains("e-appointment")) {
scheduleObj.saveEvent(data, "Save");
} else {
data.Id = scheduleObj.getEventMaxID();
scheduleObj.addEvent(data);
}
scheduleObj.closeEditor();
};
cancelButton.onclick = () => {
scheduleObj.closeEditor();
};
}
},
getName: function (value) {
return value.Subject ? value.Subject : 'Create New Event';
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month],
},
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
#verify {
position: fixed;
padding: 0 20px;
}
#text {
cursor: pointer;
display: inline-block;
font-family: "Roboto", -apple-system, BlinkMacSystemFont, "Segoe UI", "Helvetica Neue", sans-serif;
font-size: 14px;
font-weight: normal;
line-height: 14px;
user-select: none;
margin-left: 8px;
vertical-align: middle;
white-space: normal;
}
#right-button {
padding: 0 10px;
}
</style>How to add resource options within editor template
Resource selection can be added to the editor template using a MultiSelect control when assigning multiple resources to an appointment.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :group='group'>
<e-resources>
<e-resource field='OwnerId' title='Owner' name='Owners' :dataSource='ownerDataSource' textField='text'
idField='id' colorField='color'>
</e-resource>
</e-resources>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4">
<ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4">
<ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Owner</td>
<td colspan="4">
<ejs-multiselect id='OwnerId' name="OwnerId" class="e-field" placeholder= 'Choose owner' :dataSource='ownerDataSource' :fields='fields'></ejs-multiselect>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, ResourcesDirective as EResources, ResourceDirective as EResource, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { MultiSelectComponent as EjsMultiselect } from '@syncfusion/ej2-vue-dropdowns';
import { DateTimePickerComponent as EjsDatetimepicker } from '@syncfusion/ej2-vue-calendars';
import { eventData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const group = { resources: ['Owners'] };
const ownerDataSource = [
{ text: 'Nancy', id: 1, color: '#1aaa55' },
{ text: 'Smith', id: 2, color: '#7fa900' },
{ text: 'Paul', id: 3, color: '#357cd2' }
];
const fields = { text: 'text', value: 'id' };
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :group='group'>
<e-resources>
<e-resource field='OwnerId' title='Owner' name='Owners' :dataSource='ownerDataSource' textField='text'
idField='id' colorField='color'>
</e-resource>
</e-resources>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4">
<ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4">
<ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Owner</td>
<td colspan="4">
<ejs-multiselect id='OwnerId' name="OwnerId" class="e-field" placeholder= 'Choose owner' :dataSource='ownerDataSource' :fields='fields'></ejs-multiselect>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, ResourcesDirective, ResourceDirective, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';
import { MultiSelectComponent } from '@syncfusion/ej2-vue-dropdowns';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent,
"e-resources": ResourcesDirective,
"e-resource": ResourceDirective,
"ejs-datetimepicker": DateTimePickerComponent,
"ejs-multiselect" : MultiSelectComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15),
group: { resources: ['Owners'] },
ownerDataSource: [
{ text: 'Nancy', id: 1, color: '#1aaa55' },
{ text: 'Smith', id: 2, color: '#7fa900' },
{ text: 'Paul', id: 3, color: '#357cd2' }
],
fields: { text: 'text', value: 'id' },
};
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style>How to add recurrence options within editor template
Recurrence options can be added to the editor template by including RecurrenceEditor.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule ref='scheduleObj' :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'>
<template v-slot:editorTemplate="{ data }">
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4">
<ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4">
<ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Repeat</td>
<td colspan="4">
<ejs-recurrenceeditor ref="recurrenceObj" id="RecurrenceEditor" :value="data.RecurrenceRule"></ejs-recurrenceeditor>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ScheduleComponent as EjsSchedule, RecurrenceEditorComponent as EjsRecurrenceeditor, ViewDirective as EView, ViewsDirective as EViews, Day, Week, WorkWeek, Month, RecurrenceEditor } from '@syncfusion/ej2-vue-schedule';
import { DateTimePickerComponent as EjsDatetimepicker } from "@syncfusion/ej2-vue-calendars";
import { eventData } from './datasource.js';
const scheduleObj = ref(null);
const recurrenceObj = ref(null);
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
if (args.type === 'Editor') {
let schedule = scheduleObj.value.ej2Instances;
let recurrObject = recurrenceObj.value.ej2Instances;
schedule.eventWindow.recurrenceEditor = recurrObject;
document.getElementById('RecurrenceEditor').style.display = (schedule.currentAction == 'EditOccurrence') ? 'none' : 'block';
}
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
}
.custom-event-editor td {
padding: 7px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule ref='scheduleObj' :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'>
<template v-slot:editorTemplate="{ data }">
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4">
<input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4">
<ejs-datetimepicker id="StartTime" class="e-field" name="StartTime"></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4">
<ejs-datetimepicker id="EndTime" class="e-field" name="EndTime" ></ejs-datetimepicker>
</td>
</tr>
<tr>
<td class="e-textlabel">Repeat</td>
<td colspan="4">
<ejs-recurrenceeditor ref="recurrenceObj" id="RecurrenceEditor" :value="data.RecurrenceRule"></ejs-recurrenceeditor>
</td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month, RecurrenceEditorComponent } from '@syncfusion/ej2-vue-schedule';
import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent,
"ejs-datetimepicker": DateTimePickerComponent,
"ejs-recurrenceeditor": RecurrenceEditorComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15)
};
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'Editor') {
let scheduleObj = this.$refs.scheduleObj.ej2Instances;
let recurrenceObj = this.$refs.recurrenceObj.ej2Instances;
scheduleObj.eventWindow.recurrenceEditor = recurrenceObj;
document.getElementById('RecurrenceEditor').style.display = (scheduleObj.currentAction == 'EditOccurrence') ? 'none' : 'block';
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
}
.custom-event-editor td {
padding: 7px;
}
</style>Apply Validations on Editor Template Fields
In the following code example, validation has been added to the status field.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4"><input id="Subject" class="e-field e-input" type="text" value="" name="Subject"
style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><input type="text" id="EventType" name="EventType" class="e-field"
style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><input id="StartTime" class="e-field" type="text" name="StartTime" /></td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><input id="EndTime" class="e-field" type="text" name="EndTime" /></td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { FormValidator } from '@syncfusion/ej2-inputs';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { eventData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const showQuickInfo = false;
const onPopupOpen = function (args) {
if (args.type === 'Editor') {
if (!isNullOrUndefined(document.getElementById("EventType_Error"))) {
document.getElementById("EventType_Error").style.display = "none";
document.getElementById("EventType_Error").style.left = "351px";
}
let formElement = args.element.querySelector('.e-schedule-form');
let statusElement = args.element.querySelector('#EventType');
if (!statusElement.classList.contains('e-dropdownlist')) {
let dropDownListObject = new DropDownList({
placeholder: 'Choose status', value: statusElement.value,
dataSource: ['New', 'Requested', 'Confirmed'],
select: function (args) {
if (!isNullOrUndefined(document.getElementById("EventType_Error"))) {
document.getElementById("EventType_Error").style.display = "none";
}
}
});
dropDownListObject.appendTo(statusElement);
}
let validator = formElement.ej2_instances[0];
validator.addRules('EventType', { required: true });
let startElement = args.element.querySelector('#StartTime');
if (!startElement.classList.contains('e-datetimepicker')) {
new DateTimePicker({ value: new Date(startElement.value) || new Date() }, startElement);
}
let endElement = args.element.querySelector('#EndTime');
if (!endElement.classList.contains('e-datetimepicker')) {
new DateTimePicker({ value: new Date(endElement.value) || new Date() }, endElement);
}
}
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4"><input id="Subject" class="e-field e-input" type="text" value="" name="Subject"
style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><input type="text" id="EventType" name="EventType" class="e-field"
style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><input id="StartTime" class="e-field" type="text" name="StartTime" /></td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><input id="EndTime" class="e-field" type="text" name="EndTime" /></td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4">
<textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea>
</td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { FormValidator } from '@syncfusion/ej2-inputs';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15),
showQuickInfo: false
};
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'Editor') {
if (!isNullOrUndefined(document.getElementById("EventType_Error"))) {
document.getElementById("EventType_Error").style.display = "none";
document.getElementById("EventType_Error").style.left = "351px";
}
let formElement = args.element.querySelector('.e-schedule-form');
let statusElement = args.element.querySelector('#EventType');
if (!statusElement.classList.contains('e-dropdownlist')) {
let dropDownListObject = new DropDownList({
placeholder: 'Choose status', value: statusElement.value,
dataSource: ['New', 'Requested', 'Confirmed'],
select: function (args) {
if (!isNullOrUndefined(document.getElementById("EventType_Error"))) {
document.getElementById("EventType_Error").style.display = "none";
}
}
});
dropDownListObject.appendTo(statusElement);
}
let validator = formElement.ej2_instances[0];
validator.addRules('EventType', { required: true });
let startElement = args.element.querySelector('#StartTime');
if (!startElement.classList.contains('e-datetimepicker')) {
new DateTimePicker({ value: new Date(startElement.value) || new Date() }, startElement);
}
let endElement = args.element.querySelector('#EndTime');
if (!endElement.classList.contains('e-datetimepicker')) {
new DateTimePicker({ value: new Date(endElement.value) || new Date() }, endElement);
}
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style>How to save the customized event editor using template
When the e-field class is not applied to all fields in a template, the corresponding values must be manually assigned using the popupClose event.
Note: Data can be retrieved only on the save and delete options. Data cannot be retrieved on the close and cancel options in the editor window.
The following code example shows how to save the customized event editor using a template by the popupClose event.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'
:popupClose='onPopupClose'>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4"><input id="Subject" class="e-input" type="text" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><input type="text" id="EventType" name="EventType" style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><input id="StartTime" type="text" name="StartTime" /></td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><input id="EndTime" type="text" name="EndTime" /></td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4"><textarea id="Description" class="e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea></td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { eventData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: eventData
};
const selectedDate = new Date(2018, 1, 15);
const showQuickInfo = false;
const onPopupOpen = function (args) {
if (args.type === 'Editor') {
let subjectElement = args.element.querySelector('#Subject');
if (subjectElement) {
subjectElement.value = args.data.Subject || "";
}
let statusElement = args.element.querySelector('#EventType');
if (!statusElement.classList.contains('e-dropdownlist')) {
let dropDownListObject = new DropDownList({
placeholder: 'Choose status',
value: args.data.EventType,
dataSource: ['New', 'Requested', 'Confirmed']
});
dropDownListObject.appendTo(statusElement);
statusElement.setAttribute('name', 'EventType');
}
let startElement = args.element.querySelector('#StartTime');
if (!startElement.classList.contains('e-datetimepicker')) {
new DateTimePicker(
{ value: new Date(args.data.StartTime) || new Date() },
startElement
);
}
let endElement = args.element.querySelector('#EndTime');
if (!endElement.classList.contains('e-datetimepicker')) {
new DateTimePicker(
{ value: new Date(args.data.EndTime) || new Date() },
endElement
);
}
let descriptionElement = args.element.querySelector('#Description');
if (descriptionElement) {
descriptionElement.value = args.data.Description || "";
}
}
}
const onPopupClose = function (args) {
if (args.type === 'Editor' && !isNullOrUndefined(args.data)) {
let subjectElement = args.element.querySelector('#Subject');
if (subjectElement) {
args.data.Subject = subjectElement.value;
}
let statusElement = args.element.querySelector('#EventType');
if (statusElement) {
args.data.EventType = statusElement.value;
}
let startElement = args.element.querySelector('#StartTime');
if (startElement) {
args.data.StartTime = startElement.value;
}
let endElement = args.element.querySelector('#EndTime');
if (endElement) {
args.data.EndTime = endElement.value;
}
let descriptionElement = args.element.querySelector('#Description');
if (descriptionElement) {
args.data.Description = descriptionElement.value;
}
}
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :editorTemplate="'editorTemplate'" :popupOpen='onPopupOpen'
:popupClose='onPopupClose'>
<template v-slot:editorTemplate>
<table class="custom-event-editor" width="100%" cellpadding="5">
<tbody>
<tr>
<td class="e-textlabel">Summary</td>
<td colspan="4"><input id="Subject" class="e-input" type="text" name="Subject" style="width: 100%" />
</td>
</tr>
<tr>
<td class="e-textlabel">Status</td>
<td colspan="4"><input type="text" id="EventType" name="EventType" style="width: 100%" /></td>
</tr>
<tr>
<td class="e-textlabel">From</td>
<td colspan="4"><input id="StartTime" type="text" name="StartTime" /></td>
</tr>
<tr>
<td class="e-textlabel">To</td>
<td colspan="4"><input id="EndTime" type="text" name="EndTime" /></td>
</tr>
<tr>
<td class="e-textlabel">Reason</td>
<td colspan="4"><textarea id="Description" class="e-input" name="Description" rows="3" cols="50"
style="width: 100%; height: 60px !important; resize: vertical"></textarea></td>
</tr>
</tbody>
</table>
</template>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { eventData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: eventData
},
selectedDate: new Date(2018, 1, 15),
showQuickInfo: false
};
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'Editor') {
let subjectElement = args.element.querySelector('#Subject');
if (subjectElement) {
subjectElement.value = args.data.Subject || "";
}
let statusElement = args.element.querySelector('#EventType');
if (!statusElement.classList.contains('e-dropdownlist')) {
let dropDownListObject = new DropDownList({
placeholder: 'Choose status',
value: args.data.EventType,
dataSource: ['New', 'Requested', 'Confirmed']
});
dropDownListObject.appendTo(statusElement);
statusElement.setAttribute('name', 'EventType');
}
let startElement = args.element.querySelector('#StartTime');
if (!startElement.classList.contains('e-datetimepicker')) {
new DateTimePicker(
{ value: new Date(args.data.StartTime) || new Date() },
startElement
);
}
let endElement = args.element.querySelector('#EndTime');
if (!endElement.classList.contains('e-datetimepicker')) {
new DateTimePicker(
{ value: new Date(args.data.EndTime) || new Date() },
endElement
);
}
let descriptionElement = args.element.querySelector('#Description');
if (descriptionElement) {
descriptionElement.value = args.data.Description || "";
}
}
},
onPopupClose: function (args) {
if (args.type === 'Editor' && !isNullOrUndefined(args.data)) {
let subjectElement = args.element.querySelector('#Subject');
if (subjectElement) {
args.data.Subject = subjectElement.value;
}
let statusElement = args.element.querySelector('#EventType');
if (statusElement) {
args.data.EventType = statusElement.value;
}
let startElement = args.element.querySelector('#StartTime');
if (startElement) {
args.data.StartTime = startElement.value;
}
let endElement = args.element.querySelector('#EndTime');
if (endElement) {
args.data.EndTime = endElement.value;
}
let descriptionElement = args.element.querySelector('#Description');
if (descriptionElement) {
args.data.Description = descriptionElement.value;
}
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.custom-event-editor .e-textlabel {
padding-right: 15px;
text-align: right;
}
.custom-event-editor td {
padding: 7px;
padding-right: 16px;
}
</style>If you need to prevent only specific popups in the Scheduler, you can check the condition based on the popup type. The types of popups that can be checked within the popupClose event are as follows.
| Type | Description |
|---|---|
| Editor | For the detailed editor window. |
| QuickInfo | For the quick popup that opens on cell click. |
| EditEventInfo | For the quick popup that opens on event click. |
| ViewEventInfo | For the quick popup that opens in responsive mode. |
| EventContainer | For the more event indicator popup. |
| RecurrenceAlert | For the recurrence edit alert popup. |
| DeleteAlert | For the delete confirmation popup. |
| ValidationAlert | For the validation alert popup. |
| RecurrenceValidationAlert | For the recurrence validation alert popup. |
Quick Popups
Quick info popups open when a cell or appointment is single-clicked in desktop mode. When you single-click a cell, you can provide a subject and save it. When you single-click an event, a popup displays an overview of the event information. You can also edit or delete those events through the available options.
By default, these popups are displayed over Scheduler cells and appointments. To disable this behavior, set the showQuickInfo property to false.
The quick popup that opens when single-clicking cells is not applicable on mobile devices.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :showQuickInfo='showQuickInfo'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, Month, TimelineViews, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const showQuickInfo = false;
provide('schedule', [TimelineViews, Day, Week, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :showQuickInfo='showQuickInfo'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, Month, TimelineViews, Agenda } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
showQuickInfo: false,
}
},
provide: {
schedule: [TimelineViews, Day, Week, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Open QuickInfo Popup on Multiple Cell Selection
Quick popups open by default on single cell click. To open the quick popup after selecting multiple cells, press the Enter key. To open it immediately after selection, set the quickInfoOnSelectionEnd property to true.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views'
:quickInfoOnSelectionEnd='quickInfoOnSelectionEnd'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, Month, TimelineViews, Agenda } from '@syncfusion/ej2-vue-schedule';
const height = '550px';
const width = '100%';
const views = ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'];
const quickInfoOnSelectionEnd = true;
provide('schedule', [TimelineViews, Day, Week, Month, Agenda]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views'
:quickInfoOnSelectionEnd='quickInfoOnSelectionEnd'></ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, Month, TimelineViews, Agenda } from '@syncfusion/ej2-vue-schedule';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'],
quickInfoOnSelectionEnd: true,
}
},
provide: {
schedule: [TimelineViews, Day, Week, Month, Agenda]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Change the Watermark Text of Quick Popup Subject
By default, Add Title text is displayed on the subject field of quick popup. To change the default watermark text, change the value of the appropriate localized word collection used in the Scheduler.
L10n.load({
'en-US': {
'schedule': {
'addTitle' : 'New Title'
}
}
});Customizing quick popups
The look and feel of the built-in quick popup window, which opens when cells or appointments are single-clicked, can be customized using the quickInfoTemplates property of the Scheduler. There are three sub-options available to customize it:
- header - Accepts the template design that customizes the header part of the quick popup.
- content - Accepts the template design that customizes the content part of the quick popup.
- footer - Accepts the template design that customizes the footer part of the quick popup.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :quickInfoTemplates='quickInfoTemplates'>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide, createApp } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const headerTemplateVue = createApp().component('headerTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-header">
<div class="e-header-icon-wrapper"><button class="e-close" title="Close"></button></div></div></div>
<div v-else><div class="e-event-header"><div class="e-header-icon-wrapper"><button class="e-close" title="CLOSE"></button></div></div></div></div>`,
data() {
return {
data: {}
};
}
});
const contentTemplateVue = createApp().component('contentTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-content e-template">
<form class="e-schedule-form"><div><input class="subject e-field" type="text" name="Subject" placeholder="Title"></div><div><input class="location e-field" type="text" name="Location" placeholder="Location"></div></form></div></div><div v-else><div class="e-event-content e-template">
<div class="e-subject-wrap"><div><div v-if="data.Subject !== undefined"><div class="subject"></div></div></div><div><div v-if="data.Location !== undefined"><div class="location"></div></div></div><div><div v-if="data.Description !== undefined"><div class="description"></div></div></div></div></div></div></div>`,
data() {
return {
data: {}
};
}
});
const footerTemplateVue = createApp().component('footerTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-footer">
<button class="e-event-details" title="Extra Details">Extra Details</button>
<button class="e-event-create" title="Add">Add</button></div></div>
<div v-else><div class="e-event-footer"><button class="e-event-edit" title="Edit">Edit</button>
<button class="e-event-delete" title="Delete">Delete</button></div></div></div>`,
data() {
return {
data: {}
};
}
});
const height = '550px';
const width = '100%';
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const views = ['Day', 'Week', 'WorkWeek'];
const quickInfoTemplates = {
header: function () {
return {
template: headerTemplateVue
};
},
content: function () {
return {
template: contentTemplateVue
};
},
footer: function () {
return {
template: footerTemplateVue
};
}
}
provide('schedule', [Day, Week, WorkWeek]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.e-textlabel {
font-weight: bold;
padding-right: 5px;
}
.custom-event-editor td {
padding: 5px;
}
.e-quick-popup-wrapper .e-cell-content {
padding: 0 10px 10px 10px;
}
.e-quick-popup-wrapper .e-cell-content div {
padding-bottom: 10px;
}
.e-quick-popup-wrapper .e-cell-content .e-field {
border-left-width: 0;
border-top-width: 0;
border-right-width: 0;
height: 25px;
width: 100%;
}
.e-quick-popup-wrapper .e-event-content {
display: flex;
}
.e-quick-popup-wrapper .e-event-header {
position: absolute;
right: 0;
}
.e-quick-popup-wrapper .e-cell-footer .e-event-create,
.e-quick-popup-wrapper .e-event-footer .e-event-edit {
position: absolute;
right: 0;
}
.e-quick-popup-wrapper .e-event-content .subject {
padding-top: 10px;
padding-left: 10px;
font-weight: 500;
font-size: 14px;
}
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :quickInfoTemplates='quickInfoTemplates'>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { createApp } from "vue";
import { ScheduleComponent, Day, Week, WorkWeek } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const headerTemplateVue = createApp().component('headerTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-header">
<div class="e-header-icon-wrapper"><button class="e-close" title="Close"></button></div></div></div>
<div v-else><div class="e-event-header"><div class="e-header-icon-wrapper"><button class="e-close" title="CLOSE"></button></div></div></div></div>`,
data() {
return {
data: {}
};
}
});
const contentTemplateVue = createApp().component('contentTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-content e-template">
<form class="e-schedule-form"><div><input class="subject e-field" type="text" name="Subject" placeholder="Title"></div><div><input class="location e-field" type="text" name="Location" placeholder="Location"></div></form></div></div><div v-else><div class="e-event-content e-template">
<div class="e-subject-wrap"><div><div v-if="data.Subject !== undefined"><div class="subject"></div></div></div><div><div v-if="data.Location !== undefined"><div class="location"></div></div></div><div><div v-if="data.Description !== undefined"><div class="description"></div></div></div></div></div></div></div>`,
data() {
return {
data: {}
};
}
});
const footerTemplateVue = createApp().component('footerTemplate', {
template: `<div><div v-if= "data.elementType === 'cell' "><div class="e-cell-footer">
<button class="e-event-details" title="Extra Details">Extra Details</button>
<button class="e-event-create" title="Add">Add</button></div></div>
<div v-else><div class="e-event-footer"><button class="e-event-edit" title="Edit">Edit</button>
<button class="e-event-delete" title="Delete">Delete</button></div></div></div>`,
data() {
return {
data: {}
};
}
});
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
views: ['Day', 'Week', 'WorkWeek'],
quickInfoTemplates: {
header: function () {
return {
template: headerTemplateVue
};
},
content: function () {
return {
template: contentTemplateVue
};
},
footer: function () {
return {
template: footerTemplateVue
};
}
}
};
},
provide: {
schedule: [Day, Week, WorkWeek]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
.e-textlabel {
font-weight: bold;
padding-right: 5px;
}
.custom-event-editor td {
padding: 5px;
}
.e-quick-popup-wrapper .e-cell-content {
padding: 0 10px 10px 10px;
}
.e-quick-popup-wrapper .e-cell-content div {
padding-bottom: 10px;
}
.e-quick-popup-wrapper .e-cell-content .e-field {
border-left-width: 0;
border-top-width: 0;
border-right-width: 0;
height: 25px;
width: 100%;
}
.e-quick-popup-wrapper .e-event-content {
display: flex;
}
.e-quick-popup-wrapper .e-event-header {
position: absolute;
right: 0;
}
.e-quick-popup-wrapper .e-cell-footer .e-event-create,
.e-quick-popup-wrapper .e-event-footer .e-event-edit {
position: absolute;
right: 0;
}
.e-quick-popup-wrapper .e-event-content .subject {
padding-top: 10px;
padding-left: 10px;
font-weight: 500;
font-size: 14px;
}
</style>Quick info popups in adaptive mode can also be customized using
quickInfoTemplateswith the e-device class.
More Events Indicator and Popup
When the number of appointments in a particular time range exceeds the default appointment height and the default height of a cell in month view or timeline views, a + more text indicator is displayed at the bottom of those cells. This indicator denotes that the cell contains more appointments, and clicking it displays a popup with all appointments on that day.
To disable the popup that shows hidden appointments when the text indicator is clicked, customize the
popupOpenevent.
The same indicator is displayed on the all-day row in day, week, and work week views when the number of appointments in a cell exceeds three. Clicking the text indicator does not open a popup, but allows the expand or collapse option for viewing the remaining appointments in the all-day row.
The following code example shows how to disable the popup display when clicking the more text indicator.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :popupOpen='onPopupOpen'>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const currentView = 'Month';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
if (args.type === 'EventContainer') {
args.cancel = true;
}
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :popupOpen='onPopupOpen'>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
currentView: 'Month',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'EventContainer') {
args.cancel = true;
}
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Customize the Popup that Opens on more Indicator
The following code example shows how to customize the default more indicator popup so that the number of events rendered on the day is shown in the header.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { Internationalization } from '@syncfusion/ej2-base';
import { ScheduleComponent as EjsSchedule, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const views = ['Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onPopupOpen = function (args) {
if (args.type === 'EventContainer') {
let instance = new Internationalization();
let date = instance.formatDate(args.data.date, { skeleton: 'MMMEd' });
args.element.querySelector('.e-header-date').innerText = date;
args.element.querySelector('.e-header-day').innerText = 'Event count: ' + args.data.event.length;
}
}
provide('schedule', [Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
/* csslint ignore:start */
.e-schedule .e-more-popup-wrapper .e-header-date {
font-size: 15px !important;
max-width: 44% !important;
}
/* csslint ignore:end */
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:eventSettings='eventSettings' :popupOpen='onPopupOpen'></ejs-schedule>
</div>
</div>
</template>
<script>
import { Internationalization } from '@syncfusion/ej2-base';
import { ScheduleComponent, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
views: ['Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onPopupOpen: function (args) {
if (args.type === 'EventContainer') {
let instance = new Internationalization();
let date = instance.formatDate(args.data.date, { skeleton: 'MMMEd' });
args.element.querySelector('.e-header-date').innerText = date;
args.element.querySelector('.e-header-day').innerText = 'Event count: ' + args.data.event.length;
}
}
},
provide: {
schedule: [Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
/* csslint ignore:start */
.e-schedule .e-more-popup-wrapper .e-header-date {
font-size: 15px !important;
max-width: 44% !important;
}
/* csslint ignore:end */
</style>How to prevent the display of popup when clicking on the more text indicator
It is possible to prevent the popup window from being displayed by passing the value true to the cancel option within the MoreEventsClick event.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :moreEventsClick='onMoreEventsClick'>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const currentView = 'Month';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onMoreEventsClick = function (args) {
args.cancel = true;
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :moreEventsClick='onMoreEventsClick'>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
currentView: 'Month',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onMoreEventsClick: function (args) {
args.cancel = true;
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to navigate Day view when clicking on more text indicator
The following code example shows how to customize the moreEventsClick property to navigate to the Day view when clicking the more text indicator.
<template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :moreEventsClick='onMoreEventsClick'>
</ejs-schedule>
</div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
const height = '550px';
const width = '100%';
const currentView = 'Month';
const views = ['Day', 'Week', 'WorkWeek', 'Month'];
const eventSettings = {
dataSource: scheduleData
};
const selectedDate = new Date(2018, 1, 15);
const onMoreEventsClick = function (args) {
args.isPopupOpen = false;
}
provide('schedule', [Day, Week, WorkWeek, Month]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div id='app'>
<div id='container'>
<ejs-schedule :height='height' :width='width' :views='views' :selectedDate='selectedDate'
:currentView='currentView' :eventSettings='eventSettings' :moreEventsClick='onMoreEventsClick'>
</ejs-schedule>
</div>
</div>
</template>
<script>
import { ScheduleComponent, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { scheduleData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-schedule": ScheduleComponent
},
data() {
return {
height: '550px',
width: '100%',
currentView: 'Month',
views: ['Day', 'Week', 'WorkWeek', 'Month'],
eventSettings: {
dataSource: scheduleData
},
selectedDate: new Date(2018, 1, 15),
}
},
methods: {
onMoreEventsClick: function (args) {
args.isPopupOpen = false;
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Close the Editor Window Manually
The editor window can be manually closed using the closeEditor method.
<template>
<div>
<div id='app'>
<div id='container'>
<tr>
<td>
<div>
<ejs-button v-on:click='closeEditor'>Close Editor Window</ejs-button>
</div>
</td>
</tr>
<br><br>
<ejs-schedule ref='scheduleObj' width='100%' height='500px' :eventSettings='eventSettings'
:selectedDate='selectedDate'>
<e-views>
<e-view option='Day'></e-view>
<e-view option='Week'></e-view>
<e-view option='WorkWeek'></e-view>
<e-view option='Month'></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script setup>
import { provide, ref } from "vue";
import { extend } from '@syncfusion/ej2-base';
import { scheduleData } from './datasource.js';
import { ScheduleComponent as EjsSchedule, ViewDirective as EView, ViewsDirective as EViews, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
const scheduleObj = ref(null);
const eventSettings = { dataSource: extend([], scheduleData, null, true) };
const selectedDate = new Date(2018, 1, 15);
provide('schedule', [Day, Week, WorkWeek, Month]);
const closeEditor = function () {
scheduleObj.value.ej2Instances.closeEditor();
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div>
<div id='app'>
<div id='container'>
<tr>
<td>
<div>
<ejs-button v-on:click='closeEditor'>Close Editor Window</ejs-button>
</div>
</td>
</tr>
<br><br>
<ejs-schedule ref='scheduleObj' width='100%' height='500px' :eventSettings='eventSettings'
:selectedDate='selectedDate'>
<e-views>
<e-view option='Day'></e-view>
<e-view option='Week'></e-view>
<e-view option='WorkWeek'></e-view>
<e-view option='Month'></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script>
import { extend } from '@syncfusion/ej2-base';
import { scheduleData } from './datasource.js';
import { ScheduleComponent, ViewDirective, ViewsDirective, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
export default {
name: "App",
components: {
"ejs-button": ButtonComponent,
"ejs-schedule": ScheduleComponent,
"e-views": ViewsDirective,
"e-view": ViewDirective
},
data() {
return {
eventSettings: { dataSource: extend([], scheduleData, null, true) },
selectedDate: new Date(2018, 1, 15)
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
},
methods: {
closeEditor: function () {
let scheduleObj = this.$refs.scheduleObj.ej2Instances;
scheduleObj.closeEditor();
},
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Open the Quick info Popup Manually
The quick info popup can be opened manually by invoking the openQuickInfoPopup public method. Passing cell data opens the cell quick info popup; passing event data opens the event quick info popup.
<template>
<div>
<div id="app">
<div id="container">
<tr>
<td>
<div>
<ejs-button v-on:click="onCellClick">Show Cell QuickInfo Popup</ejs-button>
</div>
</td>
<td>
<div>
<ejs-button v-on:click="onEventClick">Show Event QuickInfo Popup</ejs-button>
</div>
</td>
</tr>
<br /><br />
<ejs-schedule ref='scheduleObj' width="100%" height="500px" :eventSettings="eventSettings"
:selectedDate="selectedDate">
<e-views>
<e-view option="Day"></e-view>
<e-view option="Week"></e-view>
<e-view option="WorkWeek"></e-view>
<e-view option="Month"></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script setup>
import { provide, ref } from "vue";
import { ScheduleComponent as EjsSchedule, ViewDirective as EView, ViewsDirective as EViews, Day, Week, WorkWeek, Month } from "@syncfusion/ej2-vue-schedule";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
const scheduleObj = ref(null);
const eventSettings = {
dataSource: [
{
Id: 1,
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
},
],
};
const selectedDate = new Date(2023, 2, 5);
provide('schedule', [Day, Week, WorkWeek, Month],);
const onEventClick = function () {
let schedule = scheduleObj.value.ej2Instances;
let eventData = {
Id: 1,
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
};
schedule.openQuickInfoPopup(eventData, "Save");
}
const onCellClick = function () {
let schedule = scheduleObj.value.ej2Instances;
let cellData = {
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
};
schedule.openQuickInfoPopup(cellData, "Add");
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div>
<div id="app">
<div id="container">
<tr>
<td>
<div>
<ejs-button v-on:click="onCellClick">Show Cell QuickInfo Popup</ejs-button>
</div>
</td>
<td>
<div>
<ejs-button v-on:click="onEventClick">Show Event QuickInfo Popup</ejs-button>
</div>
</td>
</tr>
<br /><br />
<ejs-schedule ref='scheduleObj' width="100%" height="500px" :eventSettings="eventSettings"
:selectedDate="selectedDate">
<e-views>
<e-view option="Day"></e-view>
<e-view option="Week"></e-view>
<e-view option="WorkWeek"></e-view>
<e-view option="Month"></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script>
import { ScheduleComponent, ViewDirective, ViewsDirective, Day, Week, WorkWeek, Month } from "@syncfusion/ej2-vue-schedule";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
export default {
name: "App",
components: {
"ejs-button": ButtonComponent,
"ejs-schedule": ScheduleComponent,
"e-views": ViewsDirective,
"e-view": ViewDirective
},
data() {
return {
eventSettings: {
dataSource: [
{
Id: 1,
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
},
],
},
selectedDate: new Date(2023, 2, 5),
};
},
provide: {
schedule: [Day, Week, WorkWeek, Month],
},
methods: {
onEventClick: function () {
let scheduleObj = this.$refs.scheduleObj.ej2Instances;
let eventData = {
Id: 1,
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
};
scheduleObj.openQuickInfoPopup(eventData, "Save");
},
onCellClick: function () {
let scheduleObj = this.$refs.scheduleObj.ej2Instances;
let cellData = {
Subject: "Review Meeting",
StartTime: new Date(2023, 2, 5, 20, 0, 0),
EndTime: new Date(2023, 2, 5, 21, 0, 0),
};
scheduleObj.openQuickInfoPopup(cellData, "Add");
},
},
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>How to Close the Quick info Popup Manually
You can close the quick info popup in the Scheduler by using the closeQuickInfoPopup public method. The following code example demonstrates how to close the quick info popup manually.
<template>
<div>
<div id='app'>
<div id='container'>
<tr>
<td>
<div>
<ejs-button v-on:click='closeQuickInfo'>Close QuickInfo Popup</ejs-button>
</div>
</td>
</tr>
<br><br>
<ejs-schedule ref='scheduleObj' width='100%' height='500px' :eventSettings='eventSettings'
:selectedDate='selectedDate'>
<e-views>
<e-view option='Day'></e-view>
<e-view option='Week'></e-view>
<e-view option='WorkWeek'></e-view>
<e-view option='Month'></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script setup>
import { provide, ref } from "vue";
import { extend } from '@syncfusion/ej2-base';
import { scheduleData } from './datasource.js';
import { ScheduleComponent as EjsSchedule, ViewDirective as EView, ViewsDirective as EViews, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
const scheduleObj = ref(null);
const eventSettings = { dataSource: extend([], scheduleData, null, true) };
const selectedDate = new Date(2018, 1, 15);
provide('schedule', [Day, Week, WorkWeek, Month]);
const closeQuickInfo = function () {
scheduleObj.value.closeQuickInfoPopup();
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style><template>
<div>
<div id='app'>
<div id='container'>
<tr>
<td>
<div>
<ejs-button v-on:click='closeQuickInfo'>Close QuickInfo Popup</ejs-button>
</div>
</td>
</tr>
<br><br>
<ejs-schedule ref='scheduleObj' width='100%' height='500px' :eventSettings='eventSettings'
:selectedDate='selectedDate'>
<e-views>
<e-view option='Day'></e-view>
<e-view option='Week'></e-view>
<e-view option='WorkWeek'></e-view>
<e-view option='Month'></e-view>
</e-views>
</ejs-schedule>
</div>
</div>
</div>
</template>
<script>
import { extend } from '@syncfusion/ej2-base';
import { scheduleData } from './datasource.js';
import { ScheduleComponent, ViewDirective, ViewsDirective, Day, Week, WorkWeek, Month } from '@syncfusion/ej2-vue-schedule';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
export default {
name: "App",
components: {
"ejs-button": ButtonComponent,
"ejs-schedule": ScheduleComponent,
"e-views": ViewsDirective,
"e-view": ViewDirective
},
data() {
return {
eventSettings: { dataSource: extend([], scheduleData, null, true) },
selectedDate: new Date(2018, 1, 15)
}
},
provide: {
schedule: [Day, Week, WorkWeek, Month]
},
methods: {
closeQuickInfo: function () {
let scheduleObj = this.$refs.scheduleObj.ej2Instances;
scheduleObj.closeQuickInfoPopup();
},
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/schedule/index.css";
</style>Refer to the Vue Scheduler feature tour page for a detailed overview. Explore the Vue Scheduler example sample for live interaction examples.

Editor Window Customization in Angular Scheduler

The Scheduler component uses popups and dialogs to display notifications and provides an editor window with event fields to simplify appointment creation and editing. The editor window and its fields can be customized, and validation rules can be applied as needed.

Event editor

The editor window opens in the Scheduler when a cell or event is double-clicked. When a cell is double-clicked, the editor window appears in “Add new” mode. When an event is double-clicked, it opens in “Edit” mode.

On mobile devices, the detailed editor window opens in edit mode by clicking the edit icon on the popup that appears after tapping an event once. To open the editor in add mode, tap a cell to display a + indicator, then tap again to open the editor window.

To prevent the editor window from opening, render the Scheduler in readonly mode or use code customization within the popupOpen event.

You can modify the header title and the text of the footer buttons in the editor window by updating the corresponding localized word collection in the Scheduler.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { L10n } from '@syncfusion/ej2-base';
import { Component } from '@angular/core';
import { EventSettingsModel,TimelineViewsService } from '@syncfusion/ej2-angular-schedule';
import { scheduleData} from './datasource';

L10n.load({
  'en-US': {
      'schedule': {
          'saveButton': 'Add',
          'cancelButton': 'Close',
          'deleteButton': 'Remove',
          'newEvent': 'Add Event',
      },
  }
});
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],
standalone: true,
  selector: 'app-root',
  providers: [DayService, WeekService, TimelineViewsService, MonthService, AgendaService, WorkWeekService, MonthAgendaService],
  // specifies the template string for the Schedule component
  template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['TimelineDay', 'Day', 'Week', 'Month', 'Agenda'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Editing Window with Custom Local Words

How to change the label text of default editor fields

To change the default labels such as “Subject,” “Location,” and other field names, use the title property within the field option of eventSettings.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { WorkWeekService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, DayService, WeekService, TimelineViewsService, MonthService, AgendaService } from '@syncfusion/ej2-angular-schedule';
import { scheduleData} from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService,
                TimelineViewsService],
standalone: true,
  selector: 'app-root',
  // specifies the template string for the Schedule component
  template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'TimelineWeek', 'Month', 'Agenda'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData,
        fields: {
            id: 'Id',
            subject: { name: 'Subject', title: 'Event Name' },
            location: { name: 'Location', title: 'Event Location'},
            description: { name: 'Description', title: 'Event Description' },
            startTime: { name: 'StartTime', title: 'Start Duration' },
            endTime: { name: 'EndTime', title: 'End Duration'  }
        }
    };
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Editor Window with Custom Label

Field validation

You can validate required fields in the editor window on the client side before submitting by adding appropriate validation rules to each field. Appointment fields can accept both string and object types. To apply validations, specify object values for the event fields.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel} from '@syncfusion/ej2-angular-schedule';
import { scheduleData} from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],


standalone: true,
  selector: 'app-root',
  providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService],
  // specifies the template string for the Schedule component
  template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings'></ejs-schedule>`
})


export class AppComponent {
    minValidation: (args: { [key: string]: string }) => boolean = (args: { [key: string]: string }) => {
        return args['value'].length >= 5;
    };
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month', 'Agenda'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData,
        fields: {
            id: 'Id',
            subject: { name: 'Subject', validation: { required: true } },
            location: { name: 'Location', validation: { required: true } },
            description: {
                name: 'Description', validation: {
                    required: true, minLength: [this.minValidation, 'Need atleast 5 letters to be entered']
                }
            },
            startTime: { name: 'StartTime', validation: { required: true } },
            endTime: { name: 'EndTime', validation: { required: true } }
        }
    };
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Editor window with Validation

See the form validation documentation for applicable validation rules.

Adding additional fields to the default editor

The additional fields can be added to the default event editor by using the popupOpen event, which is triggered before the event editor opens in the Scheduler. The popupOpen event is a client-side event that triggers before any of the generic popups open in the Scheduler. Add the additional field, or any other form elements, with a common class name e-field to process those values along with the default event object. In the following example, an additional field Event Type has been added to the default event editor and its value is processed accordingly.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { createElement } from '@syncfusion/ej2-base';
import { EventSettingsModel, PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { eventsData} from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
  selector: 'app-root',
  // specifies the template string for the Schedule component
  template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public eventSettings: EventSettingsModel = {
        dataSource: eventsData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor') {
            // Create required custom elements in initial time
            if (!args.element.querySelector('.custom-field-row')) {
                let row: HTMLElement = createElement('div', { className: 'custom-field-row' });
                let formElement: HTMLElement = args.element.querySelector('.e-schedule-form') as HTMLElement;
                formElement.firstChild?.insertBefore(row, args.element.querySelector('.e-title-location-row'));
                let container: HTMLElement = createElement('div', { className: 'custom-field-container' });
                let inputEle: HTMLInputElement = createElement('input', {
                    className: 'e-field', attrs: { name: 'EventType' }
                }) as HTMLInputElement;
                container.appendChild(inputEle);
                row.appendChild(container);
                let dropDownList: DropDownList = new DropDownList({
                    dataSource: [
                        { text: 'Public Event', value: 'public-event' },
                        { text: 'Maintenance', value: 'maintenance' },
                        { text: 'Commercial Event', value: 'commercial-event' },
                        { text: 'Family Event', value: 'family-event' }
                    ],
                    fields: { text: 'text', value: 'value' },
                    value: (<{ [key: string]: Object; }>(args.data))['EventType'] as string,
                    floatLabelType: 'Always', placeholder: 'Event Type'
                });
                dropDownList.appendTo(inputEle);
                inputEle.setAttribute('name', 'EventType');
            }
        }
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to prevent the default focus of the editor window

By default, when the editor window opens, focus is set to the subject field. You can prevent this default focusing behavior using the popupOpen event, as shown in the following code example.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewChild } from '@angular/core';
import { EventSettingsModel,PopupOpenEventArgs, ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
import { eventsData} from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
  selector: 'app-root',
  // specifies the template string for the Schedule component
  template: `<ejs-schedule #scheduleObj width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`
})


export class AppComponent {
    @ViewChild("scheduleObj")
    public scheduleObj?: ScheduleComponent;
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public eventSettings: EventSettingsModel = {
        dataSource: eventsData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor') {
            let dialog = (args.element as any).ej2_instances[0];
            dialog.open = function(args : any) {
                this.scheduleObj.eventBase.focusElement();
            };
        }
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customizing the default time duration in the editor window

The default event editor calculates start and end time durations based on the interval value set in the timeScale property. By default, the interval value is 60 minutes, so the time difference in the event editor is also 60 minutes. You can change this duration by updating the duration option within the popupOpen event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor') {
            args.duration = 60;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to prevent the display of editor and quick popups

You can prevent the display of editor and quick popup windows by setting the cancel option to true within the popupOpen event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor' || args.type === 'QuickInfo')  {
            args.cancel = true;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can also prevent only specific popups by checking the popup type within the popupOpen event. The following table details the available popup types:

Type Description
Editor For detailed editor window.
QuickInfo For quick popup that opens on cell click.
EditEventInfo For quick popup that opens on event click.
ViewEventInfo For quick popup that opens in responsive mode.
EventContainer For more event indicator popup.
RecurrenceAlert For edit recurrence event alert popup.
DeleteAlert For delete confirmation popup.
ValidationAlert For validation alert popup.
RecurrenceValidationAlert For recurrence validation alert popup.

How to prevent the display of editor in cell double click

You can prevent the editor from appearing by handling the cellDoubleClick event and setting the cancel option to true.

[src/app/app.component.ts]

import { Component } from '@angular/core';
import { scheduleData } from './data';
import { extend } from '@syncfusion/ej2-base';
import { EventSettingsModel, View, DayService, WeekService, WorkWeekService, MonthService, AgendaService, CellClickEventArgs } from '@syncfusion/ej2-angular-schedule';

@Component({
  // tslint:disable-next-line:component-selector
  selector: 'app-root',
  template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' (cellDoubleClick)='onCellDoubleClick($event)'></ejs-schedule>`,
  /* custom code end*/
  providers: [
    DayService,
    WeekService,
    WorkWeekService,
    MonthService,
    AgendaService
  ],
})
export class AppComponent {
  public data: Record<string, any>[] = ([] = extend([],scheduleData,null,true) as Record<string, any>[]);
  public selectedDate: Date = new Date(2021, 0, 10);
  public eventSettings: EventSettingsModel = { dataSource: this.data };
  public currentView: View = 'Week';
  public onCellDoubleClick(args: CellClickEventArgs): void {
    args.cancel = true;
    // Implement custom dialog if needed
  }
}

Customizing timezone collection in the editor window

By default, the editor window displays built-in timezone collections. You can customize these using the timezoneDataSource property with a collection of TimezoneFields data.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, TimelineMonthService } from '@syncfusion/ej2-angular-schedule';

@Component({
imports: [
        
        ScheduleModule,
        ButtonModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService,
                TimelineMonthService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]="selectedDate" [eventSettings]="eventSettings" ></ejs-schedule>`
})
export class AppComponent {
    public data: object[] = [{
        Id: 1,
        Subject: 'Explosion of Betelgeuse Star',
        StartTime: new Date(2020, 1, 15, 10, 0),
        EndTime: new Date(2018, 1, 15, 12, 30),
        IsAllDay: false
    },{
        Id: 2,
        Subject: 'Blue Moon Eclipse',
        StartTime: new Date(2020, 1, 16, 12, 0),
        EndTime: new Date(2018, 1, 16, 13, 0),
        IsAllDay: false
    }];
    public selectedDate: Date = new Date(2020, 1, 15);
    public eventSettings: EventSettingsModel = {
        dataSource: this.data};
    public timezoneDataSource : { Value: string, Text: string }[] = [
                    { Value: 'Pacific/Niue', Text: 'Niue' },
                    { Value: 'Pacific/Pago_Pago', Text: 'Pago Pago' },
                    { Value: 'Pacific/Honolulu', Text: 'Hawaii Time' },
                    { Value: 'Pacific/Rarotonga', Text: 'Rarotonga' },
                    { Value: 'Pacific/Tahiti', Text: 'Tahiti' },
                ]
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customizing the event editor using template

The event editor window can be customized using the editorTemplate option. Create the custom window with required fields using a script template with type text/x-template.

Each field defined within template should contain the e-field class, so as to allow the processing of those field values internally. The ID of this customized script template section is assigned to the editorTemplate option, so that these customized fields will be replaced onto the default editor window.

The e-field class is supported for the following Syncfusion components: DropDownList, DateTimePicker, MultiSelect, DatePicker, CheckBox, and TextBox. Since we have processed the field values internally for the above mentioned components.

As we are using our Angular sub-components within our editor using template in the following example, the custom defined form elements needs to be configured as required Angular components such as DropDownList and DateTimePicker within the popupOpen event. This particular step can be skipped, if the user needs to simply use the usual form elements.

Learn how to customize the Angular Scheduler’s editor window with your own design in this video:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ElementRef, ViewChild } from '@angular/core';
import { extend, isNullOrUndefined } from '@syncfusion/ej2-base';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { EventSettingsModel, PopupOpenEventArgs, ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        DropDownListModule,
        DateTimePickerModule 
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule #schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo'>
    <ng-template #editorTemplate let-data>
        <table class="custom-event-editor" width="100%" cellpadding="5">
            <tbody>
                <tr>
                    <td class="e-textlabel">Summary</td>
                    <td colspan="4">
                        <input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Status</td>
                    <td colspan="4">
                    <ejs-dropdownlist id='EventType' class="e-field" data-name="EventType" placeholder='Choose Status'
                    [dataSource]='statusData' value="">
                  </ejs-dropdownlist>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">From</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)">
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">To</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)">
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Reason</td>
                    <td colspan="4">
                    <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
                    value="" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
                    </td>
                </tr>
            </tbody>
        </table>
    </ng-template>
    </ejs-schedule>`
})


export class AppComponent {
    @ViewChild('schedule') public scheduleObj?: ScheduleComponent;
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public startDate!: Date;
    public endDate!: Date;
    public eventSettings: EventSettingsModel = {
        dataSource: eventData
    };
    public statusData: Object[] = ['New', 'Requested', 'Confirmed'];

    public startDateParser(data: string) {
        if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.startDate)) {
          return new Date(this.startDate);
        }
        return new Date();
    }

      public endDateParser(data: string) {
        if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.endDate)) {
          return new Date(this.endDate);
        }
        return new Date();
      }

      public onDateChange(args: ChangeEventArgs): void {
        if (!isNullOrUndefined(args.event as any)) {
          if (args.element.id === "StartTime") {
            this.startDate = args.value as Date;
          } else if (args.element.id === "EndTime") {
            this.endDate = args.value as Date;
          }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The editor window’s header and footer can be customized with templates using the editorHeaderTemplate and editorFooterTemplate options. Create a template script section for each, using text/x-template.

In this example, the header is customized to show the appointment’s subject via editorHeaderTemplate, while editorFooterTemplate is used to validate fields before saving or canceling the event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'
import {CommonModule} from '@angular/common';
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
  ScheduleComponent, MonthService, DayService, WeekService,
  WorkWeekService, EventSettingsModel, PopupOpenEventArgs
} from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
        
        ScheduleModule, CommonModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
  selector: 'app-root',
  encapsulation: ViewEncapsulation.None,
  template: `
  <ejs-schedule #schedule  width='100%' height='550px' [eventSettings]='eventSettings' (popupOpen)="onPopupOpen($event)">
    <ng-template #editorHeaderTemplate let-data>
      <div *ngIf="data.Subject; else createNewEvent">
        
      </div>
      <ng-template #createNewEvent>
        Create New Event
      </ng-template>
    </ng-template>
    <ng-template #editorFooterTemplate>
      <div id="verify">
        <input type="checkbox" id="check-box" value="unchecked">
        <label id="text">Verified</label>
      </div>
      <div id="right-button">
        <button id="Save" class="e-control e-btn e-primary" disabled data-ripple="true">Save</button>
        <button id="Cancel" class="e-control e-btn e-primary"  data-ripple="true">Cancel</button>
      </div>
    </ng-template>
  </ejs-schedule>`
})
export class AppComponent {
  @ViewChild('schedule') public scheduleObj?: ScheduleComponent;
  private today: Date = new Date();
  private data: Record<string, any>[] = [{
    Id: 1,
    Subject: 'Surgery - Andrew',
    StartTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 9, 0),
    EndTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 10, 0),
    IsAllDay: false
  },
  {
    Id: 2,
    Subject: 'Consulting - John',
    StartTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 10, 0),
    EndTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 11, 30),
    IsAllDay: false
  },
  {
    Id: 3,
    Subject: 'Therapy - Robert',
    StartTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 11, 30),
    EndTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 12, 30),
    IsAllDay: false
  },
  {
    Id: 4,
    Subject: 'Observation - Steven',
    StartTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 12, 30),
    EndTime: new Date(this.today.getFullYear(), this.today.getMonth(), this.today.getDate(), 13, 30),
    IsAllDay: false
  }];
  public eventSettings: EventSettingsModel = { dataSource: this.data };
  private onSaveButtonClick(args: PopupOpenEventArgs): void {
    const data: Record<string, any> = {
      Id: args.data?.['Id'],
      Subject: (args.element.querySelector('#Subject') as HTMLInputElement).value,
      StartTime: (args.element.querySelector('#StartTime') as any).ej2_instances[0].value,
      EndTime: (args.element.querySelector('#EndTime') as any).ej2_instances[0].value,
      IsAllDay: (args.element.querySelector('#IsAllDay')as HTMLInputElement).checked
    };
    if (args.target?.classList.contains('e-appointment')) {
      this.scheduleObj?.saveEvent(data, 'Save');
    } else {
      data['Id'] = this.scheduleObj?.getEventMaxID();
      this.scheduleObj?.addEvent(data);
    }
    this.scheduleObj?.closeEditor();
  }

  public onPopupOpen(args: PopupOpenEventArgs): void {
    if (args.type === 'Editor') {
      const saveButton: HTMLElement = args.element.querySelector('#Save') as HTMLElement;
      const cancelButton: HTMLElement = args.element.querySelector('#Cancel') as HTMLElement;
      const checkBox: HTMLInputElement = args.element.querySelector('#check-box') as HTMLInputElement;
      checkBox.onchange = () => {
        if (!(checkBox as HTMLInputElement).checked) {
          saveButton.setAttribute('disabled', '');
        } else {
          saveButton.removeAttribute('disabled');
        }
      };
      saveButton.onclick = () => {
        this.onSaveButtonClick(args);
      }
      cancelButton.onclick = () => {
        this.scheduleObj?.closeEditor();
      };
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to add resource options within the editor template

Resource fields can be added to the editor template using a MultiSelect control to enable multiple resource selection.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns'



import { Component, ViewChild } from '@angular/core';
import { MultiSelect } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { isNullOrUndefined } from '@syncfusion/ej2-base'
import { ScheduleComponent, EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, PopupOpenEventArgs, GroupModel,  AgendaService,
    MonthAgendaService } from '@syncfusion/ej2-angular-schedule';
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        DateTimePickerModule,
        MultiSelectModule 
    ],
standalone: true,
    selector: 'app-root',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService,
        MonthAgendaService],
    // specifies the template string for the Schedule component
    template: `<ejs-schedule #scheduleObj width='100%' height='550px' [selectedDate]='selectedDate' [views]='views'[eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo' [group]='group'>
        <e-resources>
            <e-resource field="OwnerId" title="Owner" name="Owners"
            [dataSource]="ownerDataSource"
            textField="text" idField="id" colorField="color">
            </e-resource>
        </e-resources>
        <ng-template #editorTemplate let-data>
            <table class="custom-event-editor" width="100%" cellpadding="5">
                <tbody>
                    <tr>
                        <td class="e-textlabel">Summary</td>
                        <td colspan="4">
                            <input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                        </td>
                    </tr>
                    <tr>
                    <td class="e-textlabel">From</td>
                        <td colspan="4">
                            <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                            (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)">
                            </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">To</td>
                        <td colspan="4">
                            <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                            (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)">
                            </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">Owner</td>
                        <td colspan="4">
                        <ejs-multiselect id='OwnerId' [dataSource]='ownerDataSource' [fields]='fields' placeholder='Choose a owner' value=""></ejs-multiselect>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">Reason</td>
                        <td colspan="4">
                            <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
                        </td>
                    </tr>
                </tbody>
            </table>
        </ng-template>
    </ejs-schedule>`
})


export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public startDate!: Date;
    public endDate!: Date;
    public eventSettings: EventSettingsModel = {
        dataSource: eventData
    };
    public group: GroupModel = { resources: ['Owners'] };
    public ownerDataSource: Object[] = [
        { text: "Nancy", id: 1, color: "#1aaa55" },
        { text: "Smith", id: 2, color: "#7fa900" },
        { text: "Paul", id: 3, color: "#357cd2" }
    ];
    public fields: Object = { text: 'text', value: 'id'}
    public startDateParser(data: string) {
        if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.startDate)) {
          return new Date(this.startDate);
        }
        return new Date();
    }

      public endDateParser(data: string) {
        if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.endDate)) {
          return new Date(this.endDate);
        }
        return new Date();
      }

      public onDateChange(args: ChangeEventArgs): void {
        if (!isNullOrUndefined(args.event as any)) {
          if (args.element.id === "StartTime") {
            this.startDate = args.value as Date;
          } else if (args.element.id === "EndTime") {
            this.endDate = args.value as Date;
          }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add Resource Options within Editor Template

How to add recurrence options within the editor template

The following code example shows how to add recurrence options within the editor template by importing RecurrenceEditor.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule, RecurrenceEditorModule  } from '@syncfusion/ej2-angular-schedule'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewChild } from '@angular/core';
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { extend, isNullOrUndefined } from '@syncfusion/ej2-base';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { EventSettingsModel, PopupOpenEventArgs, RecurrenceEditor, ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        RecurrenceEditorModule,
        DateTimePickerModule 
    ],
standalone: true,
    selector: 'app-root',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService,
      MonthAgendaService],
    // specifies the template string for the Schedule component
    template: `<ejs-schedule #scheduleObj width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo' (popupOpen)='onPopupOpen($event)'>
        <ng-template #editorTemplate let-data>
            <table class="custom-event-editor" width="100%" cellpadding="5">
                <tbody>
                    <tr>
                        <td class="e-textlabel">Summary</td>
                        <td colspan="4">
                            <input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                        </td>
                    </tr>
                    <tr>
                    <td class="e-textlabel">From</td>
                        <td colspan="4">
                        <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                        (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)">
                      </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">To</td>
                        <td colspan="4">
                        <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                        (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)">
                      </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="4">
                            <ejs-recurrenceeditor #recurrenceObj></ejs-recurrenceeditor>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">Reason</td>
                        <td colspan="4">
                            <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; height: 60px !important; resize: vertical"></textarea>
                        </td>
                    </tr>
                </tbody>
            </table>
        </ng-template>
    </ejs-schedule>`
})


export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    @ViewChild('recurrenceObj') recurrObject!: RecurrenceEditor;
    public selectedDate: Date = new Date(2018, 1, 15);
    public startDate!: Date;
    public endDate!: Date;
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public eventSettings: EventSettingsModel = {
        dataSource: eventData
    };

    public startDateParser(data: string) {
        if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.startDate)) {
          return new Date(this.startDate);
        }
        return new Date();
    }

      public endDateParser(data: string) {
        if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.endDate)) {
          return new Date(this.endDate);
        }
        return new Date();
      }

      public onDateChange(args: ChangeEventArgs): void {
        if (!isNullOrUndefined(args.event as any)) {
          if (args.element.id === "StartTime") {
            this.startDate = args.value as Date;
          } else if (args.element.id === "EndTime") {
            this.endDate = args.value as Date;
          }
        }
    }

    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor') {
            if (!this.recurrObject.element.classList.contains('e-recurrenceeditor')) {
                (this.scheduleObj!.eventWindow as any).recurrenceEditor = this.recurrObject;
            }
            (this.recurrObject.element)!.style.display = (this.scheduleObj!.currentAction == "EditOccurrence") ? 'none' : 'block';
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add Recurrence Options within Editor Template

Applying validation to editor template fields

The following code example demonstrates how to apply validation rules to the status field in a custom event editor.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'



import { Component} from '@angular/core';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { FormValidator } from '@syncfusion/ej2-inputs';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, AgendaService,
 MonthAgendaService, PopupOpenEventArgs, EJ2Instance } from '@syncfusion/ej2-angular-schedule';
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        DropDownListModule,
        DateTimePickerModule 
    ],
standalone: true,
    selector: 'app-root',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService,
      MonthAgendaService],
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo' (popupOpen)='onPopupOpen($event)'>
        <ng-template #editorTemplate let-data>
            <table class="custom-event-editor" width="100%" cellpadding="5">
                <tbody>
                    <tr>
                        <td class="e-textlabel">Summary</td>
                        <td colspan="4">
                            <input id="Subject" class="e-field e-input" type="text" value="" name="Subject" style="width: 100%" />
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">Status</td>
                        <td colspan="4">
                        <ejs-dropdownlist id='EventType' class="e-field" data-name="EventType" placeholder='Choose Status'
                        [dataSource]='statusData' value="" (select)="eventSelect($event)">
                      </ejs-dropdownlist>
                        </td>
                    </tr>
                    <tr>
                    <td class="e-textlabel">From</td>
                        <td colspan="4">
                        <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                        (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)">
                      </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">To</td>
                        <td colspan="4">
                        <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                        (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)">
                      </ejs-datetimepicker>
                        </td>
                    </tr>
                    <tr>
                        <td class="e-textlabel">Reason</td>
                        <td colspan="4">
                            <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50"
                                style="width: 100%; height: 60px !important; resize: vertical"></textarea>
                        </td>
                    </tr>
                </tbody>
            </table>
        </ng-template>
    </ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public startDate!: Date;
    public endDate!: Date;
    public statusData: Object[] = ['New', 'Requested', 'Confirmed'];
    public eventSettings: EventSettingsModel = {
        dataSource: eventData
    };
    public eventSelect(args: any) {
        if (!isNullOrUndefined(document.getElementById("EventType_Error")as any)) {
            document.getElementById("EventType_Error")!.style.display = "none";
        }
    }
    public startDateParser(data: string) {
        if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.startDate)) {
          return new Date(this.startDate);
        }
        return new Date();
    }

      public endDateParser(data: string) {
        if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.endDate)) {
          return new Date(this.endDate);
        }
        return new Date();
      }

      public onDateChange(args: ChangeEventArgs): void {
        if (!isNullOrUndefined(args.event as any)) {
          if (args.element.id === "StartTime") {
            this.startDate = args.value as Date;
          } else if (args.element.id === "EndTime") {
            this.endDate = args.value as Date;
          }
        }
    }

    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'Editor') {
            if (!isNullOrUndefined(document.getElementById("EventType_Error")as any)) {
                document.getElementById("EventType_Error")!.style.display = "none";
                document.getElementById("EventType_Error")!.style.left = "351px";
            }
            let formElement: HTMLElement = <HTMLElement>args.element.querySelector('.e-schedule-form');
            let validator: FormValidator = ((formElement as EJ2Instance).ej2_instances[0] as FormValidator);
            validator.addRules('EventType', { required: true });
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Editor Template with Validation

How to save the customized event editor using a template

If the e-field class is not added to template fields, set field values manually in the popupClose event.

Note: Data can be retrieved only on the save and delete options, not on close or cancel.

The following example shows how to handle saving event data by handling the popupClose event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { RatingModule } from '@syncfusion/ej2-angular-inputs'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'

import { Component, ViewChild, ElementRef } from '@angular/core';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { DateTimePicker } from '@syncfusion/ej2-calendars';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { RatingComponent } from '@syncfusion/ej2-angular-inputs';
import { EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, PopupOpenEventArgs, PopupCloseEventArgs,AgendaService, MonthAgendaService } from '@syncfusion/ej2-angular-schedule';
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        DropDownListModule,
        DateTimePickerModule,
        RatingModule  
    ],
standalone: true,
    selector: 'app-root',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService,
        MonthAgendaService],
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo' (popupOpen)='onPopupOpen($event)' (popupClose) ='onPopupClose($event)'>
    <ng-template #editorTemplate let-data>
        <table class="custom-event-editor" width="100%" cellpadding="5">
            <tbody>
                <tr>
                    <td class="e-textlabel">Summary</td>
                    <td colspan="4">
                        <input id="Subject" class="e-input" type="text" name="Subject" style="width: 100%" #subject value=""/>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Rating</td>
                    <td colspan="4">
                    <input ejs-rating id='rating1' #rating value=""/>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">From</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)" #startTime>
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">To</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)" #endTime>
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Reason</td>
                    <td colspan="4">
                        <textarea id="Description" class="e-input" name="Description" rows="3" cols="50" style="width: 100%; 
                        height: 60px !important; resize: vertical" #textArea value="" ></textarea>
                    </td>
                </tr>
            </tbody>
        </table>
    </ng-template>
    </ejs-schedule>`
})

export class AppComponent {
    @ViewChild('rating') public rating!: RatingComponent;
    @ViewChild('startTime') public startTime!: DateTimePicker;
    @ViewChild('endTime') public endTime!: DateTimePicker;
    @ViewChild('textArea') public textArea!: ElementRef<HTMLInputElement>;
    @ViewChild('subject') public subject!: ElementRef<HTMLInputElement>;
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public startDate!: Date;
    public endDate!: Date;
    public eventSettings: EventSettingsModel = {
        dataSource: eventData
    };
    public statusData: Object[] = ['New', 'Requested', 'Confirmed'];

    onPopupOpen(args: PopupOpenEventArgs) : void {
        if (args.type === 'Editor') {
            if (this.subject.nativeElement) {
                (this.subject.nativeElement as HTMLInputElement).value = ((<{ [key: string]: Object; }>(args.data))['Subject'] as string) || "";
            }
            if (this.textArea.nativeElement) {
                (this.textArea.nativeElement as HTMLInputElement).value = (<{ [key: string]: Object; }>(args.data))['Description'] as string || "";
            }
        }
    }
    onPopupClose(args: PopupCloseEventArgs) : void {
        if (args.type === 'Editor' && !isNullOrUndefined((args as any).data)) {
            if ( this.subject.nativeElement ) {
                (<{ [key: string]: Object; }>(args.data))['Subject'] = (this.subject.nativeElement as HTMLInputElement).value;
            }
            if(this.rating.element) {
                ((<{ [key: string]: Object; }>(args.data))['Rating'] as string) = (this.rating.element as HTMLInputElement).value;
            }
           
            if (this.startTime.element) {
                (<{ [key: string]: Object; }>(args.data))['StartTime'] = (this.startTime.element as HTMLInputElement).value;
            }
            
            if (this.endTime.element) {
                (<{ [key: string]: Object; }>(args.data))['EndTime'] = (this.endTime.element as HTMLInputElement).value;
            }
            if (this.textArea.nativeElement) {
                ((<{ [key: string]: Object; }>(args.data))['Description'] as string) = (this.textArea.nativeElement as HTMLInputElement).value;
            }
        }
    }

    public startDateParser(data: string) {
        if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.startDate)) {
          return new Date(this.startDate);
        }
        return new Date();
    }

    public endDateParser(data: string) {
        if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
          return new Date(data);
        } else if (!isNullOrUndefined(this.endDate)) {
          return new Date(this.endDate);
        }
        return new Date();
      }

    public onDateChange(args: ChangeEventArgs): void {
        if (!isNullOrUndefined(args.event as any)) {
          if (args.element.id === "StartTime") {
            this.startDate = args.value as Date;
          } else if (args.element.id === "EndTime") {
            this.endDate = args.value as Date;
          }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

To prevent only specific popups within the popupClose event, check the popup type. Types include:

Type Description
Editor For Detailed editor window.
QuickInfo For Quick popup which opens on cell click.
EditEventInfo For Quick popup which opens on event click.
ViewEventInfo For Quick popup which opens on responsive mode.
EventContainer For more event indicator popup.
RecurrenceAlert For edit recurrence event alert popup.
DeleteAlert For delete confirmation popup.
ValidationAlert For validation alert popup.
RecurrenceValidationAlert For recurrence validation alert popup.

How to enable save button in customized event editor using template

Initially, the e-custom-disable class is added to the Save button. Once all required fields are filled, the class is removed, enabling the button.

The code sample below enables the Save button in a custom event editor by handling keyup and change events.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { DateTimePickerModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars'



import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { extend, isNullOrUndefined } from "@syncfusion/ej2-base";
import { ChangeEventArgs } from '@syncfusion/ej2-calendars';
import { DropDownList } from "@syncfusion/ej2-dropdowns";
import { DateTimePicker } from "@syncfusion/ej2-calendars";
import { FormValidators, FormValidator, TextBox } from "@syncfusion/ej2-angular-inputs";
import { PopupOpenEventArgs, EventRenderedArgs, ScheduleComponent, MonthService, DayService, WeekService,
  WorkWeekService, EventSettingsModel, ResizeService, DragAndDropService, EJ2Instance , AgendaService, MonthAgendaService
} from "@syncfusion/ej2-angular-schedule";
import { eventData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule,
        DropDownListModule,
        DateTimePickerModule 
    ],
standalone: true,
    selector: 'app-root',
    providers: [ MonthService, DayService, WeekService, WorkWeekService, ResizeService, DragAndDropService, MonthAgendaService, AgendaService],
    encapsulation: ViewEncapsulation.None,
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo' (popupOpen)='onPopupOpen($event)' >
    <ng-template #editorTemplate let-data>
        <table class="custom-event-editor" width="100%" cellpadding="5">
            <tbody>
                <tr>
                    <td class="e-textlabel">Summary</td>
                    <td colspan="4">
                        <input id="Subject" class=" e-field e-input" type="text" name="Subject" style="width: 100%" value="" (keyup)="onChange($event)"/>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Status</td>
                    <td colspan="4">
                    <ejs-dropdownlist id='EventType' class="e-field" data-name="EventType" placeholder='Choose Status'
                    [dataSource]='statusData' value="">
                  </ejs-dropdownlist>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">From</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="StartTime" class="e-field" data-name="StartTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="startDateParser(data.startTime || data.StartTime)">
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">To</td>
                    <td colspan="4">
                    <ejs-datetimepicker id="EndTime" class="e-field" data-name="EndTime" format="M/dd/yy h:mm a"
                    (change)="onDateChange($event)" [value]="endDateParser(data.endTime || data.EndTime)">
                  </ejs-datetimepicker>
                    </td>
                </tr>
                <tr>
                    <td class="e-textlabel">Reason</td>
                    <td colspan="4">
                        <textarea id="Description" class="e-field e-input" name="Description" rows="3" cols="50" style="width: 100%; 
                        height: 60px !important; resize: vertical" value="" (keyup)="onChange($event)"></textarea>
                    </td>
                </tr>
            </tbody>
        </table>
    </ng-template>
    </ejs-schedule>`
})

export class AppComponent {
  @ViewChild("scheduleObj") scheduleObj: ScheduleComponent | undefined;
  public selectedDate: Date = new Date(2018, 1, 15);
  public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
  public showQuickInfo: Boolean = false;
  public startDate!: Date;
  public endDate!: Date;
  public eventSettings: EventSettingsModel = {
    dataSource: eventData,
    fields: {
      subject: { name: "Subject", validation: { required: true } },
      description: {
        name: "Description",
        validation: { required: true }
      }
    }
  };
  public validator?: FormValidator;
  public statusFields: Object = { text: "StatusText", value: "StatusText" };
  public StatusData: Object[] = [
    { StatusText: "New", Id: 1 },
    { StatusText: "Requested", Id: 2 },
    { StatusText: "Confirmed", Id: 3 }
  ];

  public onPopupOpen(args: PopupOpenEventArgs): void {
    if (args.type === "Editor") {
      const formElement: HTMLElement = args.element.querySelector(".e-schedule-form") as HTMLElement;
      this.validator = (formElement as EJ2Instance).ej2_instances[0] as FormValidator;
      this.validator.addRules("EventType", { required: [true, "This field is required."]});
      if (args.target!.classList.contains("e-work-cells")) {
        args.element.querySelector(".e-event-save")!.classList.add("e-custom-disable");
      }
    }
  }

  public onChange(args : any) {
    let form = (document.querySelector(".e-schedule-form") as any).ej2_instances[0];
    if (args.element && !args.e) {
      return;
    }
    let names = ["Subject", "Description", "EventType"];
    names.forEach(e => {
      form.validateRules(e);
    });
    let isValidated = false;
    let errorElements = document.querySelector(".e-dlg-content")!.querySelectorAll(".e-schedule-error");
    for (let i = 0; i < errorElements.length; i++) {
      isValidated =(errorElements[i] as any).style.display === "none" ? true : false;
      if (isValidated === false) {
        break;
      }
    }
    let saveBtn = document.querySelector(".e-custom-disable");
    if (isValidated && saveBtn) {
      saveBtn.classList.remove("e-custom-disable");
    } else if (!isValidated && !saveBtn) {
      document.querySelector(".e-event-save")!.classList.add("e-custom-disable");
    }
  }

  public statusData: Object[] = ['New', 'Requested', 'Confirmed'];

  public startDateParser(data: string) {
      if (isNullOrUndefined(this.startDate) && !isNullOrUndefined(data)) {
        return new Date(data);
      } else if (!isNullOrUndefined(this.startDate)) {
        return new Date(this.startDate);
      }
      return new Date();
  }

    public endDateParser(data: string) {
      if (isNullOrUndefined(this.endDate) && !isNullOrUndefined(data)) {
        return new Date(data);
      } else if (!isNullOrUndefined(this.endDate)) {
        return new Date(this.endDate);
      }
      return new Date();
    }

    public onDateChange(args: ChangeEventArgs): void {
      if (!isNullOrUndefined(args.event as any)) {
        if (args.element.id === "StartTime") {
          this.startDate = args.value as Date;
        } else if (args.element.id === "EndTime") {
          this.endDate = args.value as Date;
        }
      }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Quick popups

Quick info popups open when a cell or appointment is single-clicked in desktop mode. When you single-click a cell, you can enter a subject and save it. When you single-click an event, a popup shows an overview of the event information. You can also edit or delete those events using the available options.

By default, popups are displayed over cells and appointments. To disable, set showQuickInfo to false.

The quick popup that opens while single clicking on the cells are not applicable on mobile devices.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel} from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [eventSettings]='eventSettings' [showQuickInfo]='showQuickInfo'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfo: Boolean = false;
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to open QuickInfo popup on multiple cell selection

By default, the QuickInfo popup opens on a single click of the cell. To open the quick info popup after multiple cell selection, select the cells and press the enter key. You can open this popup immediately after multiple cell selection by setting quickInfoOnSelectionEnd to true; its default value is false.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [views]='views' [quickInfoOnSelectionEnd]='showQuickInfoOnSelectionEnd'></ejs-schedule>`
})


export class AppComponent {
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public showQuickInfoOnSelectionEnd: Boolean = true;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to change the watermark text of quick popup subject

By default, Add Title text is displayed on the subject field of quick popup. To change the default watermark text, change the value of the appropriate localized word collection used in the Scheduler.

L10n.load({
    'en-US': {
        'schedule': {
          'addTitle' : 'New Title'
        }
    }
});

Customizing quick popups

The look and feel of the built-in quick popup window, which opens when cells or appointments are single-clicked, can be customized by using the quickInfoTemplates property of the Scheduler. There are three sub-options available to customize it:

  • header - Accepts the template design that customizes the header part of the quick popup.
  • content - Accepts the template design that customizes the content part of the quick popup.
  • footer - Accepts the template design that customizes the footer part of the quick popup.
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'


import { CommonModule } from '@angular/common';
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { ScheduleComponent, CurrentAction, EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, PopupOpenEventArgs,  AgendaService,
  MonthAgendaService } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule, CommonModule
    ],
standalone: true,
    selector: 'app-root',
    providers: [DayService, WeekService, WorkWeekService, MonthService,  AgendaService,
      MonthAgendaService],
    // specifies the template string for the Schedule component
    template: `<ejs-schedule #scheduleObj width='100%' height='550px' [selectedDate]="selectedDate" [eventSettings]="eventSettings"
    (popupOpen)="onPopupOpen($event)">

    <!-- Header template -->
    <ng-template #quickInfoTemplatesHeader let-data>
      <div *ngIf="data.elementType == 'cell' || data.elementType == 'event'">
        <div class="e-popup-header">
          <div class="e-header-icon-wrapper">
            <div *ngIf="data.elementType == 'event'" class="subject"></div>
            <button class="e-close e-close-icon e-icons" title="Close" (click)="onCloseClick()"></button>
          </div>
        </div>
      </div>
    </ng-template>

    <!-- Content Template -->
    <ng-template #quickInfoTemplatesContent let-data>
      <div *ngIf="data.elementType == 'cell'" class="e-cell-content">
        <form class="e-schedule-form">
          <div style="padding:10px">
            <input class="subject e-field e-input" type="text" name="Subject" placeholder="Title" style="width:100%">
          </div>
          <div style="padding:10px">
            <input class="location e-field e-input" type="text" name="Location" placeholder="Location" style="width:100%">
          </div>
        </form>
      </div>
      <div *ngIf="data.elementType == 'event'" class="e-event-content">
        <div class="start-time">Start: </div>
        <div class="end-time">End: </div>
        <div *ngIf="data.Location != undefined && data.Location != ''" class="location">Location: </div>
      </div>
    </ng-template>

    <!-- Footer Template -->
    <ng-template #quickInfoTemplatesFooter let-data>
      <div *ngIf="data.elementType == 'cell'" class="e-cell-footer">
        <div class="left-button">
          <button class="e-event-details" title="Extra Details" (click)="onDetailsClick($event)">More Details</button>
        </div>
        <div class="right-button">
          <button class="e-event-create" title="Add" (click)="onAddClick($event)">Add</button>
        </div>
      </div>
      <div *ngIf="data.elementType == 'event'" class="e-event-footer">
        <div class="left-button">
          <button class="e-delete" title="Delete" (click)="onDeleteClick($event)">Delete</button>
          <button *ngIf="data.RecurrenceRule != undefined && data.RecurrenceRule != ''" class="e-delete-series"
            title="Delete" (click)="onDeleteClick($event)">Delete Series</button>
        </div>
        <div class="right-button">
          <button class="e-edit" title="Edit" (click)="onEditClick($event)">Edit</button>
          <button *ngIf="data.RecurrenceRule != undefined && data.RecurrenceRule != ''" class="e-edit-series"
            title="Edit" (click)="onEditClick($event)">Edit Series</button>
        </div>
      </div>
    </ng-template>
  </ejs-schedule>`,
    styleUrls: ['./index.css'],
    encapsulation: ViewEncapsulation.None,
})


export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    public selectedDate: Date = new Date(2018, 1, 15);
    private selectionTarget: Element | undefined;
    public onPopupOpen(args: PopupOpenEventArgs): void {
        this.selectionTarget = undefined;
        this.selectionTarget = args.target;
    }
    public onDetailsClick(Data: any): void {
        this.onCloseClick();
        const data: Object = this.scheduleObj?.getCellDetails(this.scheduleObj.getSelectedElements()) as Object;
        this.scheduleObj?.openEditor(data, 'Add');
    }
    public onAddClick(Data: any): void {
        this.onCloseClick();
        const data: Object = this.scheduleObj?.getCellDetails(this.scheduleObj.getSelectedElements()) as Object;
        const eventData: { [key: string]: Object } | undefined= this.scheduleObj?.eventWindow.getObjectFromFormData('e-quick-popup-wrapper');
        this.scheduleObj?.eventWindow.convertToEventData(data as { [key: string]: Object }, eventData as any);
        (eventData as any)['Id'] = this.scheduleObj?.eventBase.getEventMaxID() as number + 1;
        this.scheduleObj?.addEvent(eventData as any);
    }
    public onEditClick(args: any): void {
        if (this.selectionTarget) {
        let eventData: { [key: string]: Object } = this.scheduleObj?.getEventDetails(this.selectionTarget) as { [key: string]: Object };
        let currentAction: CurrentAction = 'Save';
        if (!isNullOrUndefined(eventData['RecurrenceRule']) && eventData['RecurrenceRule'] !== '') {
            if (args.target.classList.contains('e-edit-series')) {
            currentAction = 'EditSeries';
            eventData  = this.scheduleObj?.eventBase.getParentEvent(eventData, true) as any;
            } else {
            currentAction = 'EditOccurrence';
            }
        }
        this.scheduleObj?.openEditor(eventData, currentAction);
        }
    }
    public onDeleteClick(args: any): void {
        this.onCloseClick();
        if (this.selectionTarget) {
        const eventData: { [key: string]: Object } = this.scheduleObj?.getEventDetails(this.selectionTarget) as { [key: string]: Object };
        let currentAction: CurrentAction = 'Delete';
        if (!isNullOrUndefined(eventData['RecurrenceRule']) && eventData['RecurrenceRule'] !== '') {
            currentAction = args.target.classList.contains('e-delete-series') ? 'DeleteSeries' : 'DeleteOccurrence';
        }
        this.scheduleObj?.deleteEvent(eventData, currentAction);
        }
    }
    public onCloseClick(): void {
        this.scheduleObj?.quickPopup.quickPopupHide();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Quick popups in adaptive mode can also be customized using quickInfoTemplates and the e-device class.

More events indicator and popup

When the number of appointments in a particular time range multiplied by the default appointment height exceeds the default height of a cell in month view and all other timeline views, a + more text indicator is displayed at the bottom of those cells. This indicator shows that the cell contains additional appointments, and clicking it displays a popup with all appointments present on that day.

To disable this option of showing popup with all hidden appointments, while clicking on the text indicator, you can do code customization within the popupOpen event.

The same indicator is displayed on the all-day row in calendar views such as day, week, and work week views when the number of appointments in a cell exceeds three. Clicking the text indicator does not open a popup, but lets you expand or collapse the remaining appointments in the all-day row.

The following code example shows how to disable the display of such popups while clicking on the more text indicator.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [currentView]='currentView' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public currentView: string = 'Month';
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'EventContainer') {
            args.cancel = true;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

More Event Popup

How to customize the popup that opens on more indicator

The following code example shows how to customize the default more indicator popup so that the number of events rendered for the day appears in the header.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewEncapsulation } from '@angular/core';
import { Internationalization } from '@syncfusion/ej2-base';
import { EventSettingsModel, PopupOpenEventArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [currentView]='currentView' [cssClass]='cssClass' [eventSettings]='eventSettings' (popupOpen)='onPopupOpen($event)'></ejs-schedule>`,
    styleUrls: ['./index.css'],
    encapsulation: ViewEncapsulation.None
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public currentView: string = 'Month';
    public cssClass: string = 'schedule-more-indicator';
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'EventContainer') {
            let instance: Internationalization = new Internationalization();
            let date: string  = instance.formatDate((<any>args.data).date, { skeleton: 'MMMEd' });
            ((args.element.querySelector('.e-header-date')) as HTMLElement).innerText = date;
            ((args.element.querySelector('.e-header-day')) as HTMLElement).innerText = 'Event count: ' + (<any>args.data).event.length;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to customize the appointments rendered on more indicator popup

The following code example shows how to customize the details shown for the appointments in the more indicator popup.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { Internationalization, createElement } from '@syncfusion/ej2-base';
import { EventSettingsModel,PopupOpenEventArgs,  ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule #scheduleObj width='100%' height='650px' cssClass="more-indicator-app" [selectedDate]="selectedDate" [views]="views" [eventSettings]="eventSettings" (popupOpen)="onPopupOpen($event)">
    </ejs-schedule>`,
    styles: [`.more-indicator-app .e-more-popup-wrapper .e-appointment {
        display: inline-grid;
        height: 60px;
    }

    .more-indicator-app .e-more-popup-wrapper .e-appointment .e-subject {
        white-space: initial;
    }`],
    encapsulation: ViewEncapsulation.None
})


export class AppComponent {
    @ViewChild('scheduleObj') public scheduleObj?: ScheduleComponent;
    public selectedDate: Date = new Date(2018, 1, 1);
    public views: Array<string> = ['Month'];
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };

    private instance: Internationalization = new Internationalization();
    getTimeString(value: Date): string {
        return this.instance.formatDate(value, { format: 'hh:mm:a : dd-MMM-y' });
    }

    onPopupOpen(args: PopupOpenEventArgs): void {
        if (args.type === 'EventContainer') {
            let appointments = args.element.querySelectorAll('.e-appointment');
            for (let i = 0; i < appointments.length; i++) {
                let eventData = this.scheduleObj?.getEventDetails(appointments[i]) as { [key: string]: Object };
                let time = this.getTimeString(eventData['StartTime'] as Date) + ' - ' + this.getTimeString(eventData['EndTime'] as Date);
                let customElement = createElement('div', { className: 'e-more-popup-event-time' });
                customElement.innerText = time;
                appointments[i].insertBefore(customElement, appointments[i].firstChild);
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to prevent the display of popup when clicking on the more text indicator

To prevent the popup window from appearing, set the cancel property to true in the MoreEventsClick event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, MoreEventsClickArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [currentView]='currentView' [eventSettings]='eventSettings' (moreEventsClick)='onMoreEventsClick($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public currentView: string = 'Month';
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onMoreEventsClick(args: MoreEventsClickArgs): void {
        args.cancel = true;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to navigate Day view when clicking on more text indicator

The following code example shows how to customize the MoreEventsClick event to navigate to the Day view when clicking the more text indicator.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component } from '@angular/core';
import { EventSettingsModel, MoreEventsClickArgs } from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<ejs-schedule width='100%' height='550px' [selectedDate]='selectedDate' [views]='views' [currentView]='currentView' [eventSettings]='eventSettings' (moreEventsClick)='onMoreEventsClick($event)'></ejs-schedule>`
})


export class AppComponent {
    public selectedDate: Date = new Date(2018, 1, 15);
    public views: Array<string> = ['Day', 'Week', 'WorkWeek', 'Month'];
    public currentView: string = 'Month';
    public eventSettings: EventSettingsModel = {
        dataSource: scheduleData
    };
    onMoreEventsClick(args: MoreEventsClickArgs): void {
        args.isPopupOpen = false;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to close the editor window manually

You can close the editor window by using closeEditor method.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { ButtonComponent } from '@syncfusion/ej2-angular-buttons';
import { EventSettingsModel, ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<button ejs-button cssClass= 'e-custom-close'  (click)='closeEditor()'> closeEditor </button> <ejs-schedule #scheduleObj width='100%' height='650px' cssClass="more-indicator-app" [selectedDate]="selectedDate" [views]="views" [eventSettings]="eventSettings"></ejs-schedule>`,
})
export class AppComponent {
    @ViewChild('scheduleObj') public scheduleObj?: ScheduleComponent;
        public selectedDate: Date = new Date(2023, 2, 5);
        public views: Array<string> = ['Month'];
        public eventSettings: EventSettingsModel = {
        dataSource: [{
            Id: 1,
            Subject: 'Review Meeting',
            StartTime: new Date(2023, 2, 5, 20, 0, 0),
            EndTime: new Date(2023, 2, 5, 21, 0, 0)
        }]
    };
    closeEditor(): void {
         this.scheduleObj?.closeEditor();
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to open the quick info popup manually

You can open the quick info popup in scheduler by using the openQuickInfoPopup public method. To open the cell quick info popup, you can pass the cell data as an argument to the method. To open the event quick info popup, you should pass the event data object as an argument to the method.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewChild } from '@angular/core';
import { EventSettingsModel, ScheduleComponent} from '@syncfusion/ej2-angular-schedule';

@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<button ejs-button cssClass= 'e-custom-close' (click)='cellClick()'> Show Cell Click Popup </button>
  <button ejs-button cssClass= 'e-custom-close' (click)='eventClick()'> Show Event Click Popup </button>
  <ejs-schedule #scheduleObj width='100%' height='550px' [selectedDate]="selectedDate" [eventSettings]="eventSettings" > <e-views> <e-view option="Week"></e-view> <e-view option="WorkWeek"></e-view> <e-view option="Month"></e-view> <e-view option="Day"></e-view> </e-views> </ejs-schedule>`
})
export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    public selectedDate: Date = new Date(2023, 2, 5);
    public eventSettings: EventSettingsModel = {
        dataSource: [{
            Id: 1,
            Subject: 'Review Meeting',
            StartTime: new Date(2023, 2, 5, 9, 0, 0),
            EndTime: new Date(2023, 2, 5, 10, 0, 0)
        }]
    };
    cellClick(): void {
        let cellData: Object = {
            Subject: 'Review Meeting',
            StartTime: new Date(2023, 2, 5, 9, 0, 0),
            EndTime: new Date(2023, 2, 5, 10, 0, 0)
        };
        this.scheduleObj?.openQuickInfoPopup(cellData);
    }
    eventClick(): void {
        let eventData: Object = {
            Id: 1,
            Subject: 'Review Meeting',
            StartTime: new Date(2023, 2, 5, 9, 0, 0),
            EndTime: new Date(2023, 2, 5, 10, 0, 0)
        };
        this.scheduleObj?.openQuickInfoPopup(eventData);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to close the quick info popup manually

You can close the quick info popup in Scheduler by using the closeQuickInfoPopup public method. The following code example demonstrates how to close the quick info popup manually.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService} from '@syncfusion/ej2-angular-schedule'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { ButtonComponent } from '@syncfusion/ej2-angular-buttons';
import { EventSettingsModel, ScheduleComponent } from '@syncfusion/ej2-angular-schedule';
@Component({
imports: [
        
        ScheduleModule,
        TimePickerModule
    ],

providers: [DayService, 
                WeekService, 
                WorkWeekService, 
                MonthService,
                AgendaService,
                MonthAgendaService],
standalone: true,
    selector: 'app-root',
    // specifies the template string for the Schedule component
    template: `<button ejs-button cssClass= 'e-custom-close' (click)="CloseQuickInfoPopup">CloseQuickInfoPopup</button> <ejs-schedule #scheduleObj width='100%' height='650px' cssClass="more-indicator-app" [selectedDate]="selectedDate" [views]="views" [eventSettings]="eventSettings"></ejs-schedule>`,
})
export class AppComponent {
    @ViewChild('scheduleObj') public scheduleObj?: ScheduleComponent;
        public selectedDate: Date = new Date(2023, 2, 5);
        public views: Array<string> = ['Month'];
        public eventSettings: EventSettingsModel = {
        dataSource: [{
            Id: 1,
            Subject: 'Review Meeting',
            StartTime: new Date(2023, 2, 5, 20, 0, 0),
            EndTime: new Date(2023, 2, 5, 21, 0, 0)
        }]
    };
    CloseQuickInfoPopup(): void {
         this.scheduleObj?.closeQuickInfoPopup();
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can refer to our Angular Scheduler feature tour page for feature highlights. You can also explore our Angular Scheduler example to see how to present and manipulate data.